#ifndef MOBIES_UMLMODEL_H
#define MOBIES_UMLMODEL_H
// header file UMLModel.h generated from diagram UMLModel
// generated on Fri Feb 03 09:37:39 2006

#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif

namespace JavaModel
{ 
	 class  JClass;
	 class  JInheritance;
};


namespace UMLModel {

	class  Attribute;
	class  Inheritance;
	class  Operation;
	class  Agregation;
	class  Class;
	class  Feature;
	class  ClassHasFeature;
	class  UML;
	class  RootFolder;
	class  MgaObject;

	  void Initialize();

	  void Initialize(const Uml::Diagram &dgr);
	extern  Udm::UdmDiagram diagram;

	class  RootFolder :  public Udm::Object
	{
	 public:
		static Uml::Class meta;

		RootFolder() { }
		RootFolder(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) { }
		RootFolder(const RootFolder &master) : UDM_OBJECT(master) { }
		static RootFolder Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static RootFolder Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		RootFolder CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		RootFolder CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<RootFolder> Instances() { return Udm::InstantiatedAttr<UMLModel::RootFolder>(impl);}
		template <class Pred> Udm::InstantiatedAttr<RootFolder, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<UMLModel::RootFolder, Pred>(impl);}

		Udm::DerivedAttr<UMLModel::RootFolder> Derived() { return Udm::DerivedAttr<UMLModel::RootFolder>(impl);}
		template <class Pred> Udm::DerivedAttr<UMLModel::RootFolder, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<UMLModel::RootFolder, Pred>(impl);}

		Udm::ArchetypeAttr<UMLModel::RootFolder> Archetype() { return Udm::ArchetypeAttr<UMLModel::RootFolder>(impl);}

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::CompositionChildRole meta_RootFolder_children;
		Udm::ChildrenAttr<UMLModel::RootFolder> RootFolder_children() const { return Udm::ChildrenAttr<UMLModel::RootFolder>(impl, meta_RootFolder_children); }
		 template <class Pred> Udm::ChildrenAttr<UMLModel::RootFolder, Pred> RootFolder_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::RootFolder, Pred>(impl, meta_RootFolder_children); }

		static Uml::CompositionChildRole meta_UML_children;
		Udm::ChildrenAttr<UMLModel::UML> UML_children() const { return Udm::ChildrenAttr<UMLModel::UML>(impl, meta_UML_children); }
		 template <class Pred> Udm::ChildrenAttr<UMLModel::UML, Pred> UML_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::UML, Pred>(impl, meta_UML_children); }

		Udm::ChildrenAttr<UMLModel::UML> UML_kind_children() const { return Udm::ChildrenAttr<UMLModel::UML>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<UMLModel::UML, Pred> UML_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::UML, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<UMLModel::RootFolder> RootFolder_kind_children() const { return Udm::ChildrenAttr<UMLModel::RootFolder>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<UMLModel::RootFolder, Pred> RootFolder_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::RootFolder, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<UMLModel::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<UMLModel::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<UMLModel::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<UMLModel::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<UMLModel::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<UMLModel::RootFolder> parent() const { return Udm::ParentAttr<UMLModel::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

	class  MgaObject :  public Udm::Object
	{
	 public:
		static Uml::Class meta;

		MgaObject() { }
		MgaObject(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) { }
		MgaObject(const MgaObject &master) : UDM_OBJECT(master) { }
		static MgaObject Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static MgaObject Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		MgaObject CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		MgaObject CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<MgaObject> Instances() { return Udm::InstantiatedAttr<UMLModel::MgaObject>(impl);}
		template <class Pred> Udm::InstantiatedAttr<MgaObject, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<UMLModel::MgaObject, Pred>(impl);}

		Udm::DerivedAttr<UMLModel::MgaObject> Derived() { return Udm::DerivedAttr<UMLModel::MgaObject>(impl);}
		template <class Pred> Udm::DerivedAttr<UMLModel::MgaObject, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<UMLModel::MgaObject, Pred>(impl);}

		Udm::ArchetypeAttr<UMLModel::MgaObject> Archetype() { return Udm::ArchetypeAttr<UMLModel::MgaObject>(impl);}

		static Uml::Attribute meta_position;
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  Attribute :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		Attribute() { }
		Attribute(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Attribute(const Attribute &master) : MgaObject(master) { }
		static Attribute Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Attribute Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Attribute CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Attribute CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Attribute> Instances() { return Udm::InstantiatedAttr<UMLModel::Attribute>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Attribute, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<UMLModel::Attribute, Pred>(impl);}

		Udm::DerivedAttr<UMLModel::Attribute> Derived() { return Udm::DerivedAttr<UMLModel::Attribute>(impl);}
		template <class Pred> Udm::DerivedAttr<UMLModel::Attribute, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<UMLModel::Attribute, Pred>(impl);}

		Udm::ArchetypeAttr<UMLModel::Attribute> Archetype() { return Udm::ArchetypeAttr<UMLModel::Attribute>(impl);}

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  Inheritance :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		Inheritance() { }
		Inheritance(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Inheritance(const Inheritance &master) : MgaObject(master) { }
		static Inheritance Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Inheritance Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Inheritance CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Inheritance CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Inheritance> Instances() { return Udm::InstantiatedAttr<UMLModel::Inheritance>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Inheritance, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<UMLModel::Inheritance, Pred>(impl);}

		Udm::DerivedAttr<UMLModel::Inheritance> Derived() { return Udm::DerivedAttr<UMLModel::Inheritance>(impl);}
		template <class Pred> Udm::DerivedAttr<UMLModel::Inheritance, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<UMLModel::Inheritance, Pred>(impl);}

		Udm::ArchetypeAttr<UMLModel::Inheritance> Archetype() { return Udm::ArchetypeAttr<UMLModel::Inheritance>(impl);}

		static Uml::AssociationRole meta_dst;
		Udm::CrossAssocAttr<JavaModel::JInheritance> dst() const { return Udm::CrossAssocAttr<JavaModel::JInheritance>(impl, meta_dst); }
		template<class Pred> Udm::CrossAssocAttr<JavaModel::JInheritance, Pred> dst_sorted(const Pred &) const { return Udm::CrossAssocAttr<JavaModel::JInheritance, Pred>(impl, meta_dst); }

		static Uml::CompositionParentRole meta_UML_parent;
		Udm::ParentAttr<UMLModel::UML> UML_parent() const { return Udm::ParentAttr<UMLModel::UML>(impl, meta_UML_parent); }

		Udm::ParentAttr<UMLModel::MgaObject> parent() const { return Udm::ParentAttr<UMLModel::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dstInheritance_end_;
		Udm::AssocEndAttr<UMLModel::Class> dstInheritance_end() const { return Udm::AssocEndAttr<UMLModel::Class>(impl, meta_dstInheritance_end_); }

		static Uml::AssociationRole meta_srcInheritance_end_;
		Udm::AssocEndAttr<UMLModel::Class> srcInheritance_end() const { return Udm::AssocEndAttr<UMLModel::Class>(impl, meta_srcInheritance_end_); }

	};

	class  Operation :  public Attribute
	{
	 public:
		static Uml::Class meta;

		Operation() { }
		Operation(Udm::ObjectImpl *impl) : Attribute(impl) { }
		Operation(const Operation &master) : Attribute(master) { }
		static Operation Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Operation Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Operation CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Operation CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Operation> Instances() { return Udm::InstantiatedAttr<UMLModel::Operation>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Operation, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<UMLModel::Operation, Pred>(impl);}

		Udm::DerivedAttr<UMLModel::Operation> Derived() { return Udm::DerivedAttr<UMLModel::Operation>(impl);}
		template <class Pred> Udm::DerivedAttr<UMLModel::Operation, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<UMLModel::Operation, Pred>(impl);}

		Udm::ArchetypeAttr<UMLModel::Operation> Archetype() { return Udm::ArchetypeAttr<UMLModel::Operation>(impl);}

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  Agregation :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		Agregation() { }
		Agregation(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Agregation(const Agregation &master) : MgaObject(master) { }
		static Agregation Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Agregation Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Agregation CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Agregation CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Agregation> Instances() { return Udm::InstantiatedAttr<UMLModel::Agregation>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Agregation, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<UMLModel::Agregation, Pred>(impl);}

		Udm::DerivedAttr<UMLModel::Agregation> Derived() { return Udm::DerivedAttr<UMLModel::Agregation>(impl);}
		template <class Pred> Udm::DerivedAttr<UMLModel::Agregation, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<UMLModel::Agregation, Pred>(impl);}

		Udm::ArchetypeAttr<UMLModel::Agregation> Archetype() { return Udm::ArchetypeAttr<UMLModel::Agregation>(impl);}

		static Uml::CompositionParentRole meta_UML_parent;
		Udm::ParentAttr<UMLModel::UML> UML_parent() const { return Udm::ParentAttr<UMLModel::UML>(impl, meta_UML_parent); }

		Udm::ParentAttr<UMLModel::MgaObject> parent() const { return Udm::ParentAttr<UMLModel::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dstAgregation_end_;
		Udm::AssocEndAttr<UMLModel::Class> dstAgregation_end() const { return Udm::AssocEndAttr<UMLModel::Class>(impl, meta_dstAgregation_end_); }

		static Uml::AssociationRole meta_srcAgregation_end_;
		Udm::AssocEndAttr<UMLModel::Class> srcAgregation_end() const { return Udm::AssocEndAttr<UMLModel::Class>(impl, meta_srcAgregation_end_); }

	};

	class  Class :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		Class() { }
		Class(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Class(const Class &master) : MgaObject(master) { }
		static Class Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Class Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Class CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Class CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Class> Instances() { return Udm::InstantiatedAttr<UMLModel::Class>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Class, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<UMLModel::Class, Pred>(impl);}

		Udm::DerivedAttr<UMLModel::Class> Derived() { return Udm::DerivedAttr<UMLModel::Class>(impl);}
		template <class Pred> Udm::DerivedAttr<UMLModel::Class, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<UMLModel::Class, Pred>(impl);}

		Udm::ArchetypeAttr<UMLModel::Class> Archetype() { return Udm::ArchetypeAttr<UMLModel::Class>(impl);}

		static Uml::AssociationRole meta_srcInheritance;
		static Uml::AssociationRole meta_srcInheritance_rev;
		Udm::AClassAssocAttr<UMLModel::Inheritance, UMLModel::Class> srcInheritance() const { return Udm::AClassAssocAttr<UMLModel::Inheritance, UMLModel::Class>(impl, meta_srcInheritance, meta_srcInheritance_rev); }
		template<class Pred> Udm::AClassAssocAttr<UMLModel::Inheritance, UMLModel::Class, Pred> srcInheritance_sorted(const Pred &) const { return Udm::AClassAssocAttr<UMLModel::Inheritance, UMLModel::Class, Pred>(impl, meta_srcInheritance, meta_srcInheritance_rev); }

		static Uml::AssociationRole meta_dstInheritance;
		static Uml::AssociationRole meta_dstInheritance_rev;
		Udm::AClassAssocAttr<UMLModel::Inheritance, UMLModel::Class> dstInheritance() const { return Udm::AClassAssocAttr<UMLModel::Inheritance, UMLModel::Class>(impl, meta_dstInheritance, meta_dstInheritance_rev); }
		template<class Pred> Udm::AClassAssocAttr<UMLModel::Inheritance, UMLModel::Class, Pred> dstInheritance_sorted(const Pred &) const { return Udm::AClassAssocAttr<UMLModel::Inheritance, UMLModel::Class, Pred>(impl, meta_dstInheritance, meta_dstInheritance_rev); }

		static Uml::AssociationRole meta_srcAgregation;
		static Uml::AssociationRole meta_srcAgregation_rev;
		Udm::AClassAssocAttr<UMLModel::Agregation, UMLModel::Class> srcAgregation() const { return Udm::AClassAssocAttr<UMLModel::Agregation, UMLModel::Class>(impl, meta_srcAgregation, meta_srcAgregation_rev); }
		template<class Pred> Udm::AClassAssocAttr<UMLModel::Agregation, UMLModel::Class, Pred> srcAgregation_sorted(const Pred &) const { return Udm::AClassAssocAttr<UMLModel::Agregation, UMLModel::Class, Pred>(impl, meta_srcAgregation, meta_srcAgregation_rev); }

		static Uml::AssociationRole meta_dstAgregation;
		static Uml::AssociationRole meta_dstAgregation_rev;
		Udm::AClassAssocAttr<UMLModel::Agregation, UMLModel::Class> dstAgregation() const { return Udm::AClassAssocAttr<UMLModel::Agregation, UMLModel::Class>(impl, meta_dstAgregation, meta_dstAgregation_rev); }
		template<class Pred> Udm::AClassAssocAttr<UMLModel::Agregation, UMLModel::Class, Pred> dstAgregation_sorted(const Pred &) const { return Udm::AClassAssocAttr<UMLModel::Agregation, UMLModel::Class, Pred>(impl, meta_dstAgregation, meta_dstAgregation_rev); }

		static Uml::AssociationRole meta_dstClassHasFeature;
		static Uml::AssociationRole meta_dstClassHasFeature_rev;
		Udm::AClassAssocAttr<UMLModel::ClassHasFeature, UMLModel::Feature> dstClassHasFeature() const { return Udm::AClassAssocAttr<UMLModel::ClassHasFeature, UMLModel::Feature>(impl, meta_dstClassHasFeature, meta_dstClassHasFeature_rev); }
		template<class Pred> Udm::AClassAssocAttr<UMLModel::ClassHasFeature, UMLModel::Feature, Pred> dstClassHasFeature_sorted(const Pred &) const { return Udm::AClassAssocAttr<UMLModel::ClassHasFeature, UMLModel::Feature, Pred>(impl, meta_dstClassHasFeature, meta_dstClassHasFeature_rev); }

		static Uml::AssociationRole meta_dst;
		Udm::CrossAssocAttr<JavaModel::JClass> dst() const { return Udm::CrossAssocAttr<JavaModel::JClass>(impl, meta_dst); }
		template<class Pred> Udm::CrossAssocAttr<JavaModel::JClass, Pred> dst_sorted(const Pred &) const { return Udm::CrossAssocAttr<JavaModel::JClass, Pred>(impl, meta_dst); }

		static Uml::CompositionParentRole meta_UML_parent;
		Udm::ParentAttr<UMLModel::UML> UML_parent() const { return Udm::ParentAttr<UMLModel::UML>(impl, meta_UML_parent); }

		Udm::ParentAttr<UMLModel::MgaObject> parent() const { return Udm::ParentAttr<UMLModel::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  Feature :  public Attribute
	{
	 public:
		static Uml::Class meta;

		Feature() { }
		Feature(Udm::ObjectImpl *impl) : Attribute(impl) { }
		Feature(const Feature &master) : Attribute(master) { }
		static Feature Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Feature Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Feature CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Feature CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Feature> Instances() { return Udm::InstantiatedAttr<UMLModel::Feature>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Feature, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<UMLModel::Feature, Pred>(impl);}

		Udm::DerivedAttr<UMLModel::Feature> Derived() { return Udm::DerivedAttr<UMLModel::Feature>(impl);}
		template <class Pred> Udm::DerivedAttr<UMLModel::Feature, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<UMLModel::Feature, Pred>(impl);}

		Udm::ArchetypeAttr<UMLModel::Feature> Archetype() { return Udm::ArchetypeAttr<UMLModel::Feature>(impl);}

		static Uml::AssociationRole meta_srcClassHasFeature;
		static Uml::AssociationRole meta_srcClassHasFeature_rev;
		Udm::AClassPointerAttr<UMLModel::ClassHasFeature, UMLModel::Class> srcClassHasFeature() const { return Udm::AClassPointerAttr<UMLModel::ClassHasFeature, UMLModel::Class>(impl, meta_srcClassHasFeature, meta_srcClassHasFeature_rev); }

		static Uml::CompositionParentRole meta_UML_parent;
		Udm::ParentAttr<UMLModel::UML> UML_parent() const { return Udm::ParentAttr<UMLModel::UML>(impl, meta_UML_parent); }

		Udm::ParentAttr<UMLModel::MgaObject> parent() const { return Udm::ParentAttr<UMLModel::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  ClassHasFeature :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		ClassHasFeature() { }
		ClassHasFeature(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		ClassHasFeature(const ClassHasFeature &master) : MgaObject(master) { }
		static ClassHasFeature Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static ClassHasFeature Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		ClassHasFeature CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		ClassHasFeature CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<ClassHasFeature> Instances() { return Udm::InstantiatedAttr<UMLModel::ClassHasFeature>(impl);}
		template <class Pred> Udm::InstantiatedAttr<ClassHasFeature, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<UMLModel::ClassHasFeature, Pred>(impl);}

		Udm::DerivedAttr<UMLModel::ClassHasFeature> Derived() { return Udm::DerivedAttr<UMLModel::ClassHasFeature>(impl);}
		template <class Pred> Udm::DerivedAttr<UMLModel::ClassHasFeature, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<UMLModel::ClassHasFeature, Pred>(impl);}

		Udm::ArchetypeAttr<UMLModel::ClassHasFeature> Archetype() { return Udm::ArchetypeAttr<UMLModel::ClassHasFeature>(impl);}

		static Uml::CompositionParentRole meta_UML_parent;
		Udm::ParentAttr<UMLModel::UML> UML_parent() const { return Udm::ParentAttr<UMLModel::UML>(impl, meta_UML_parent); }

		Udm::ParentAttr<UMLModel::MgaObject> parent() const { return Udm::ParentAttr<UMLModel::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_srcClassHasFeature_end_;
		Udm::AssocEndAttr<UMLModel::Class> srcClassHasFeature_end() const { return Udm::AssocEndAttr<UMLModel::Class>(impl, meta_srcClassHasFeature_end_); }

		static Uml::AssociationRole meta_dstClassHasFeature_end_;
		Udm::AssocEndAttr<UMLModel::Feature> dstClassHasFeature_end() const { return Udm::AssocEndAttr<UMLModel::Feature>(impl, meta_dstClassHasFeature_end_); }

	};

	class  UML :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		UML() { }
		UML(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		UML(const UML &master) : MgaObject(master) { }
		static UML Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static UML Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		UML CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		UML CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<UML> Instances() { return Udm::InstantiatedAttr<UMLModel::UML>(impl);}
		template <class Pred> Udm::InstantiatedAttr<UML, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<UMLModel::UML, Pred>(impl);}

		Udm::DerivedAttr<UMLModel::UML> Derived() { return Udm::DerivedAttr<UMLModel::UML>(impl);}
		template <class Pred> Udm::DerivedAttr<UMLModel::UML, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<UMLModel::UML, Pred>(impl);}

		Udm::ArchetypeAttr<UMLModel::UML> Archetype() { return Udm::ArchetypeAttr<UMLModel::UML>(impl);}

		static Uml::CompositionChildRole meta_Inheritance_children;
		Udm::ChildrenAttr<UMLModel::Inheritance> Inheritance_children() const { return Udm::ChildrenAttr<UMLModel::Inheritance>(impl, meta_Inheritance_children); }
		 template <class Pred> Udm::ChildrenAttr<UMLModel::Inheritance, Pred> Inheritance_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::Inheritance, Pred>(impl, meta_Inheritance_children); }

		static Uml::CompositionChildRole meta_Class_children;
		Udm::ChildrenAttr<UMLModel::Class> Class_children() const { return Udm::ChildrenAttr<UMLModel::Class>(impl, meta_Class_children); }
		 template <class Pred> Udm::ChildrenAttr<UMLModel::Class, Pred> Class_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::Class, Pred>(impl, meta_Class_children); }

		static Uml::CompositionChildRole meta_Agregation_children;
		Udm::ChildrenAttr<UMLModel::Agregation> Agregation_children() const { return Udm::ChildrenAttr<UMLModel::Agregation>(impl, meta_Agregation_children); }
		 template <class Pred> Udm::ChildrenAttr<UMLModel::Agregation, Pred> Agregation_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::Agregation, Pred>(impl, meta_Agregation_children); }

		static Uml::CompositionChildRole meta_ClassHasFeature_children;
		Udm::ChildrenAttr<UMLModel::ClassHasFeature> ClassHasFeature_children() const { return Udm::ChildrenAttr<UMLModel::ClassHasFeature>(impl, meta_ClassHasFeature_children); }
		 template <class Pred> Udm::ChildrenAttr<UMLModel::ClassHasFeature, Pred> ClassHasFeature_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::ClassHasFeature, Pred>(impl, meta_ClassHasFeature_children); }

		static Uml::CompositionChildRole meta_Feature_children;
		Udm::ChildrenAttr<UMLModel::Feature> Feature_children() const { return Udm::ChildrenAttr<UMLModel::Feature>(impl, meta_Feature_children); }
		 template <class Pred> Udm::ChildrenAttr<UMLModel::Feature, Pred> Feature_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::Feature, Pred>(impl, meta_Feature_children); }

		Udm::ChildrenAttr<UMLModel::Attribute> Attribute_kind_children() const { return Udm::ChildrenAttr<UMLModel::Attribute>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<UMLModel::Attribute, Pred> Attribute_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::Attribute, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<UMLModel::Inheritance> Inheritance_kind_children() const { return Udm::ChildrenAttr<UMLModel::Inheritance>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<UMLModel::Inheritance, Pred> Inheritance_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::Inheritance, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<UMLModel::Agregation> Agregation_kind_children() const { return Udm::ChildrenAttr<UMLModel::Agregation>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<UMLModel::Agregation, Pred> Agregation_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::Agregation, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<UMLModel::Class> Class_kind_children() const { return Udm::ChildrenAttr<UMLModel::Class>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<UMLModel::Class, Pred> Class_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::Class, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<UMLModel::Feature> Feature_kind_children() const { return Udm::ChildrenAttr<UMLModel::Feature>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<UMLModel::Feature, Pred> Feature_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::Feature, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<UMLModel::ClassHasFeature> ClassHasFeature_kind_children() const { return Udm::ChildrenAttr<UMLModel::ClassHasFeature>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<UMLModel::ClassHasFeature, Pred> ClassHasFeature_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::ClassHasFeature, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<UMLModel::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<UMLModel::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<UMLModel::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<UMLModel::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<UMLModel::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<UMLModel::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<UMLModel::RootFolder> parent() const { return Udm::ParentAttr<UMLModel::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

}

#endif //MOBIES_UMLMODEL_H
