/* GenMI2SI.cpp generated on Wed Dec 07 13:18:05 2005
 */

#include "GenMI2SI.h"
#include <UmlExt.h>
#include <UdmUtil.h>
#include "GReATSort.h"
#include "MI2SI-gr_genops.h"

void NewBlock_0::operator()( const Packets_t& javaIns_1, const Packets_t& uMLIns_3)
{
#ifdef PRINT_INFO
	std::cout << "NewBlock_0" << std::endl;
#endif
	if( ( !uMLIns_3.empty())&& ( !javaIns_1.empty()))
		callFirstRule_167( uMLIns_3, javaIns_1);
}

void NewBlock_0::callFirstRule_167( const Packets_t& rootFolders_e1, const Packets_t& rootFolders_e3)
{
	Packets_t uMLs_e0;
	Packets_t javas_e5;
	FirstRule_df firstRule_df;
	firstRule_df( rootFolders_e1, rootFolders_e3, uMLs_e0, javas_e5);
	if( ( !uMLs_e0.empty())&& ( !javas_e5.empty()))
		callCopyClasses_16a( uMLs_e0, javas_e5);
}

void NewBlock_0::callCopyClasses_16a( const Packets_t& uMLs_7, const Packets_t& javas_9)
{
	Packets_t classs_6;
	Packets_t jClasss_b;
	CopyClasses_5 copyClasses_5;
	copyClasses_5( uMLs_7, javas_9, classs_6, jClasss_b);
	if( ( !jClasss_b.empty())&& ( !classs_6.empty()))
		callTest_16d( jClasss_b, classs_6);
}

void NewBlock_0::callTest_16d( const Packets_t& javaIns_93, const Packets_t& uMLIns_95)
{
	Packets_t grandParentOuts_97;
	Packets_t childOuts_98;
	Packets_t javaOuts_99;
	Test_92 test_92;
	test_92( javaIns_93, uMLIns_95, grandParentOuts_97, childOuts_98, javaOuts_99);
	if( ( !grandParentOuts_97.empty())&& ( !childOuts_98.empty())&& ( !javaOuts_99.empty()))
		callSecondRule_170( grandParentOuts_97, childOuts_98, javaOuts_99);
}

void NewBlock_0::callSecondRule_170( const Packets_t& grandParentClasss_2d, const Packets_t& childClasss_30, const Packets_t& grandParentJClasss_33)
{
	Packets_t myParentClasss_2c;
	Packets_t grandParentClasss_2f;
	Packets_t childClasss_32;
	Packets_t grandParentJClasss_35;
	Packets_t abstractJClasss_36;
	SecondRule_2b secondRule_2b;
	secondRule_2b( grandParentClasss_2d, childClasss_30, grandParentJClasss_33, myParentClasss_2c, grandParentClasss_2f, childClasss_32, grandParentJClasss_35, abstractJClasss_36);
	if( ( !grandParentClasss_2f.empty())&& ( !myParentClasss_2c.empty())&& ( !childClasss_32.empty())&& ( !grandParentJClasss_35.empty())&& ( !abstractJClasss_36.empty()))
		callThirdRule_174( grandParentClasss_2f, myParentClasss_2c, childClasss_32, grandParentJClasss_35, abstractJClasss_36);
}

void NewBlock_0::callThirdRule_174( const Packets_t& grandParentClasss_106, const Packets_t& myParentClasss_108, const Packets_t& childClasss_10a, const Packets_t& grandJClasss_10c, const Packets_t& abstractJClasss_10e)
{
	ThirdRule_105 thirdRule_105;
	thirdRule_105( grandParentClasss_106, myParentClasss_108, childClasss_10a, grandJClasss_10c, abstractJClasss_10e);
}

void CopyClasses_5::operator()( const Packets_t& uMLs_7, const Packets_t& javas_9, Packets_t& classs_6, Packets_t& jClasss_b)
{
#ifdef PRINT_INFO
	std::cout << "CopyClasses_5" << std::endl;
#endif
	_class_c= &classs_6;
	_jClass_d= &jClasss_b;
	processInputPackets( uMLs_7, javas_9);
}

bool CopyClasses_5::isInputUnique( const Udm::Object& uML_12, const Udm::Object& java_1b)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itUML_14= _uML_e.begin(), itJava_1d= _java_17.begin(); itUML_14!= _uML_e.end(), itJava_1d!= _java_17.end(); ++itUML_14, ++itJava_1d)
	{
		if( ( *itUML_14== uML_12)&& ( *itJava_1d== java_1b))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_uML_e.push_back( uML_12);
		_java_17.push_back( java_1b);
	}
	return isUnique;
}

void CopyClasses_5::processInputPackets( const Packets_t& uMLs_7, const Packets_t& javas_9)
{
	for( Packets_t::const_iterator itUML_f= uMLs_7.begin(), itJava_18= javas_9.begin(); itUML_f!= uMLs_7.end(), itJava_18!= javas_9.end(); ++itUML_f, ++itJava_18)
	{
		bool isUnique= isInputUnique( *itUML_f, *itJava_18);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itUML_f, *itJava_18);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool CopyClasses_5::patternMatcher( const Udm::Object& uML_10, const Udm::Object& java_19)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( uML_10.type(), UMLModel::UML::meta))
			continue;
		UMLModel::UML uML_15= UMLModel::UML::Cast( uML_10);
		if( false== Uml::IsDerivedFrom( java_19.type(), JavaModel::Java::meta))
			continue;
		JavaModel::Java java_1e= JavaModel::Java::Cast( java_19);
		set< UMLModel::Class> classs_20= uML_15.Class_kind_children();
		for( set< UMLModel::Class>::const_iterator itClass_21= classs_20.begin(); itClass_21!= classs_20.end(); ++itClass_21)
		{
			UMLModel::Class currClass_22= *itClass_21;
			Match currMatch;
			currMatch.class_23= currClass_22;
			currMatch.uML_24= uML_15;
			currMatch.java_25= java_1e;
			_matches.push_back( currMatch);
		}
	}
	return !_matches.empty();
}

void CopyClasses_5::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		JavaModel::JClass newJClass_26= JavaModel::JClass::Create( currMatch.java_25);
		UMLModel::Class& Class= currMatch.class_23;
		JavaModel::JClass& JClass= newJClass_26;
		JavaModel::Java& Java= currMatch.java_25;
		UMLModel::UML& UML= currMatch.uML_24;
		{JClass.name() = Class.name(); JClass.position() = Class.position();};
		currMatch.class_23.dst()+= newJClass_26;
		outputAppender( currMatch.class_23, newJClass_26);
	}
}

void CopyClasses_5::outputAppender( const UMLModel::Class& class_27, const JavaModel::JClass& jClass_29)
{
	_class_c->push_back( class_27);
	_jClass_d->push_back( jClass_29);
}

void SecondRule_2b::operator()( const Packets_t& grandParentClasss_2d, const Packets_t& childClasss_30, const Packets_t& grandParentJClasss_33, Packets_t& myParentClasss_2c, Packets_t& grandParentClasss_2f, Packets_t& childClasss_32, Packets_t& grandParentJClasss_35, Packets_t& abstractJClasss_36)
{
#ifdef PRINT_INFO
	std::cout << "SecondRule_2b" << std::endl;
#endif
	_myParentClass_37= &myParentClasss_2c;
	_grandParentClass_38= &grandParentClasss_2f;
	_childClass_39= &childClasss_32;
	_grandParentJClass_3a= &grandParentJClasss_35;
	_abstractJClass_3b= &abstractJClasss_36;
	processInputPackets( grandParentClasss_2d, childClasss_30, grandParentJClasss_33);
}

bool SecondRule_2b::isInputUnique( const Udm::Object& grandParentClass_40, const Udm::Object& childClass_49, const Udm::Object& grandParentJClass_52)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itGrandParentClass_42= _grandParentClass_3c.begin(), itChildClass_4b= _childClass_45.begin(), itGrandParentJClass_54= _grandParentJClass_4e.begin(); itGrandParentClass_42!= _grandParentClass_3c.end(), itChildClass_4b!= _childClass_45.end(), itGrandParentJClass_54!= _grandParentJClass_4e.end(); ++itGrandParentClass_42, ++itChildClass_4b, ++itGrandParentJClass_54)
	{
		if( ( *itGrandParentClass_42== grandParentClass_40)&& ( *itChildClass_4b== childClass_49)&& ( *itGrandParentJClass_54== grandParentJClass_52))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_grandParentClass_3c.push_back( grandParentClass_40);
		_childClass_45.push_back( childClass_49);
		_grandParentJClass_4e.push_back( grandParentJClass_52);
	}
	return isUnique;
}

void SecondRule_2b::processInputPackets( const Packets_t& grandParentClasss_2d, const Packets_t& childClasss_30, const Packets_t& grandParentJClasss_33)
{
	for( Packets_t::const_iterator itGrandParentClass_3d= grandParentClasss_2d.begin(), itChildClass_46= childClasss_30.begin(), itGrandParentJClass_4f= grandParentJClasss_33.begin(); itGrandParentClass_3d!= grandParentClasss_2d.end(), itChildClass_46!= childClasss_30.end(), itGrandParentJClass_4f!= grandParentJClasss_33.end(); ++itGrandParentClass_3d, ++itChildClass_46, ++itGrandParentJClass_4f)
	{
		bool isUnique= isInputUnique( *itGrandParentClass_3d, *itChildClass_46, *itGrandParentJClass_4f);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itGrandParentClass_3d, *itChildClass_46, *itGrandParentJClass_4f);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool SecondRule_2b::patternMatcher( const Udm::Object& grandParentClass_3e, const Udm::Object& childClass_47, const Udm::Object& grandParentJClass_50)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( grandParentClass_3e.type(), UMLModel::Class::meta))
			continue;
		UMLModel::Class grandParentClass_43= UMLModel::Class::Cast( grandParentClass_3e);
		if( false== Uml::IsDerivedFrom( childClass_47.type(), UMLModel::Class::meta))
			continue;
		UMLModel::Class childClass_4c= UMLModel::Class::Cast( childClass_47);
		if( false== Uml::IsDerivedFrom( grandParentJClass_50.type(), JavaModel::JClass::meta))
			continue;
		JavaModel::JClass grandParentJClass_55= JavaModel::JClass::Cast( grandParentJClass_50);
		set< JavaModel::JClass> grandParentJClasss_57= grandParentClass_43.dst();
		for( set< JavaModel::JClass>::const_iterator itGrandParentJClasss_58= grandParentJClasss_57.begin(); itGrandParentJClasss_58!= grandParentJClasss_57.end(); ++itGrandParentJClasss_58)
		{
			JavaModel::JClass currGrandParentJClass_59= *itGrandParentJClasss_58;
			if( grandParentJClass_55!= currGrandParentJClass_59)
				continue;
			Udm::Object grandParentJClassParent_5a= grandParentJClass_55.container();
			if( false== Uml::IsDerivedFrom( grandParentJClassParent_5a.type(), JavaModel::Java::meta))
				continue;
			JavaModel::Java javaGrandParentJClass_5b= JavaModel::Java::Cast( grandParentJClassParent_5a);
			set< JavaModel::JClass> childJClasss_5c= javaGrandParentJClass_5b.JClass_kind_children();
			for( set< JavaModel::JClass>::const_iterator itChildJClass_5d= childJClasss_5c.begin(); itChildJClass_5d!= childJClasss_5c.end(); ++itChildJClass_5d)
			{
				JavaModel::JClass currChildJClass_5e= *itChildJClass_5d;
				// Composition identity check.
				if( ( grandParentJClass_55!= currChildJClass_5e))
				{
					set< JavaModel::JClass> childJClasss_5f= childClass_4c.dst();
					for( set< JavaModel::JClass>::const_iterator itChildJClasss_60= childJClasss_5f.begin(); itChildJClasss_60!= childJClasss_5f.end(); ++itChildJClasss_60)
					{
						JavaModel::JClass currChildJClass_61= *itChildJClasss_60;
						if( currChildJClass_5e!= currChildJClass_61)
							continue;
						set< JavaModel::JClass> myParentJClasss_62= javaGrandParentJClass_5b.JClass_kind_children();
						for( set< JavaModel::JClass>::const_iterator itMyParentJClass_63= myParentJClasss_62.begin(); itMyParentJClass_63!= myParentJClasss_62.end(); ++itMyParentJClass_63)
						{
							JavaModel::JClass currMyParentJClass_64= *itMyParentJClass_63;
							// Composition identity check.
							if( ( grandParentJClass_55!= currMyParentJClass_64)&& ( currChildJClass_5e!= currMyParentJClass_64))
							{
								set< UMLModel::Class> myParentClasss_65= currMyParentJClass_64.src();
								for( set< UMLModel::Class>::const_iterator itMyParentClasss_66= myParentClasss_65.begin(); itMyParentClasss_66!= myParentClasss_65.end(); ++itMyParentClasss_66)
								{
									UMLModel::Class currMyParentClass_67= *itMyParentClasss_66;
									set< UMLModel::Inheritance> inheritances_68= currMyParentClass_67.dstInheritance();
									for( set< UMLModel::Inheritance>::const_iterator itInheritances_69= inheritances_68.begin(); itInheritances_69!= inheritances_68.end(); ++itInheritances_69)
									{
										UMLModel::Inheritance currInheritance_6a= *itInheritances_69;
										UMLModel::Class childClass_6b= currInheritance_6a.dstInheritance_end();
										if( childClass_4c!= childClass_6b)
											continue;
										set< UMLModel::Inheritance> inheritances_6c= grandParentClass_43.dstInheritance();
										for( set< UMLModel::Inheritance>::const_iterator itInheritances_6d= inheritances_6c.begin(); itInheritances_6d!= inheritances_6c.end(); ++itInheritances_6d)
										{
											UMLModel::Inheritance currInheritance_6e= *itInheritances_6d;
											UMLModel::Class myParentClass_6f= currInheritance_6e.dstInheritance_end();
											if( currMyParentClass_67!= myParentClass_6f)
												continue;
											set< UMLModel::Inheritance> inheritances_70= childClass_4c.srcInheritance();
											for( set< UMLModel::Inheritance>::const_iterator itInheritances_71= inheritances_70.begin(); itInheritances_71!= inheritances_70.end(); ++itInheritances_71)
											{
												UMLModel::Inheritance currInheritance_72= *itInheritances_71;
												UMLModel::Class parentClass_73= currInheritance_72.srcInheritance_end();
												set< UMLModel::Inheritance> inheritances_74= grandParentClass_43.dstInheritance();
												for( set< UMLModel::Inheritance>::const_iterator itInheritances_75= inheritances_74.begin(); itInheritances_75!= inheritances_74.end(); ++itInheritances_75)
												{
													UMLModel::Inheritance currInheritance_76= *itInheritances_75;
													// Simple association identity check.
													if( ( currInheritance_6e!= currInheritance_76))
													{
														UMLModel::Class parentClass_77= currInheritance_76.dstInheritance_end();
														if( parentClass_73!= parentClass_77)
															continue;
														Match currMatch;
														currMatch.inheritance_78= currInheritance_6a;
														currMatch.myParentClass_79= currMyParentClass_67;
														currMatch.inheritance_7a= currInheritance_6e;
														currMatch.grandParentClass_7b= grandParentClass_43;
														currMatch.parentClass_7c= parentClass_73;
														currMatch.childClass_7d= childClass_4c;
														currMatch.inheritance_7e= currInheritance_76;
														currMatch.inheritance_7f= currInheritance_72;
														currMatch.grandParentJClass_80= grandParentJClass_55;
														currMatch.myParentJClass_81= currMyParentJClass_64;
														currMatch.childJClass_82= currChildJClass_5e;
														currMatch.java_83= javaGrandParentJClass_5b;
														_matches.push_back( currMatch);
														return true;
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	return !_matches.empty();
}

void SecondRule_2b::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		JavaModel::JInheritance newJInheritance_84= JavaModel::JInheritance::Create( currMatch.java_83);
		JavaModel::JInheritance newJInheritance_85= JavaModel::JInheritance::Create( currMatch.java_83);
		JavaModel::JClass newAbstractJClass_86= JavaModel::JClass::Create( currMatch.java_83);
		JavaModel::JAgregation newJAgregation_87= JavaModel::JAgregation::Create( currMatch.java_83);
		JavaModel::JClass& AbstractJClass= newAbstractJClass_86;
		UMLModel::Class& ChildClass= currMatch.childClass_7d;
		JavaModel::JClass& ChildJClass= currMatch.childJClass_82;
		UMLModel::Class& GrandParentClass= currMatch.grandParentClass_7b;
		JavaModel::JClass& GrandParentJClass= currMatch.grandParentJClass_80;
		JavaModel::JAgregation& JAgregation= newJAgregation_87;
		JavaModel::Java& Java= currMatch.java_83;
		UMLModel::Class& MyParentClass= currMatch.myParentClass_79;
		JavaModel::JClass& MyParentJClass= currMatch.myParentJClass_81;
		UMLModel::Class& ParentClass= currMatch.parentClass_7c;
		{AbstractJClass.name() = ((string) GrandParentJClass.name())  + "_Abs";};
		newJAgregation_87.srcJAgregation_end()= currMatch.grandParentJClass_80;
		newJAgregation_87.dstJAgregation_end()= newAbstractJClass_86;
		newJInheritance_84.srcJInheritance_end()= currMatch.myParentJClass_81;
		newJInheritance_84.dstJInheritance_end()= currMatch.childJClass_82;
		newJInheritance_85.srcJInheritance_end()= currMatch.grandParentJClass_80;
		newJInheritance_85.dstJInheritance_end()= currMatch.myParentJClass_81;
		outputAppender( currMatch.myParentClass_79, currMatch.grandParentClass_7b, currMatch.childClass_7d, currMatch.grandParentJClass_80, newAbstractJClass_86);
	}
}

void SecondRule_2b::outputAppender( const UMLModel::Class& myParentClass_88, const UMLModel::Class& grandParentClass_8a, const UMLModel::Class& childClass_8c, const JavaModel::JClass& grandParentJClass_8e, const JavaModel::JClass& abstractJClass_90)
{
	_myParentClass_37->push_back( myParentClass_88);
	_grandParentClass_38->push_back( grandParentClass_8a);
	_childClass_39->push_back( childClass_8c);
	_grandParentJClass_3a->push_back( grandParentJClass_8e);
	_abstractJClass_3b->push_back( abstractJClass_90);
}

void Test_92::operator()( const Packets_t& javaIns_93, const Packets_t& uMLIns_95, Packets_t& grandParentOuts_97, Packets_t& childOuts_98, Packets_t& javaOuts_99)
{
#ifdef PRINT_INFO
	std::cout << "Test_92" << std::endl;
#endif
	_grandParentOut_9a= &grandParentOuts_97;
	_childOut_9b= &childOuts_98;
	_javaOut_9c= &javaOuts_99;
	for( Packets_t::const_iterator itJavaIn_9e= javaIns_93.begin(), itUMLIn_a5= uMLIns_95.begin(); itJavaIn_9e!= javaIns_93.end(), itUMLIn_a5!= uMLIns_95.end(); ++itJavaIn_9e, ++itUMLIn_a5)
	{
		bool isUnique= isInputUnique( *itJavaIn_9e, *itUMLIn_a5);
		if( !isUnique)
			continue;
		Packets_t oneJavaIn_a2( 1, *itJavaIn_9e);
		Packets_t oneUMLIn_a9( 1, *itUMLIn_a5);
		executeOne( oneJavaIn_a2, oneUMLIn_a9);
	}
}

void Test_92::executeOne( const Packets_t& javaIns_93, const Packets_t& uMLIns_95)
{
	Packets_t grandParentClasss_ae;
	Packets_t childClasss_af;
	Packets_t jClasss_b2;
	Case_ab case_ab;
	bool isMatchCase_ab= case_ab( uMLIns_95, javaIns_93, grandParentClasss_ae, childClasss_af, jClasss_b2);
	_grandParentOut_9a->insert( _grandParentOut_9a->end(), grandParentClasss_ae.begin(), grandParentClasss_ae.end());
	_childOut_9b->insert( _childOut_9b->end(), childClasss_af.begin(), childClasss_af.end());
	_javaOut_9c->insert( _javaOut_9c->end(), jClasss_b2.begin(), jClasss_b2.end());
}

bool Test_92::isInputUnique( const Udm::Object& javaIn_9f, const Udm::Object& uMLIn_a6)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itJavaIn_a1= _javaIn_9d.begin(), itUMLIn_a8= _uMLIn_a4.begin(); itJavaIn_a1!= _javaIn_9d.end(), itUMLIn_a8!= _uMLIn_a4.end(); ++itJavaIn_a1, ++itUMLIn_a8)
	{
		if( ( *itJavaIn_a1== javaIn_9f)&& ( *itUMLIn_a8== uMLIn_a6))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_javaIn_9d.push_back( javaIn_9f);
		_uMLIn_a4.push_back( uMLIn_a6);
	}
	return isUnique;
}

bool Case_ab::operator()( const Packets_t& grandParentClasss_ac, const Packets_t& jClasss_b0, Packets_t& grandParentClasss_ae, Packets_t& childClasss_af, Packets_t& jClasss_b2)
{
#ifdef PRINT_INFO
	std::cout << "Case_ab" << std::endl;
#endif
	_grandParentClass_b3= &grandParentClasss_ae;
	_childClass_b4= &childClasss_af;
	_jClass_b5= &jClasss_b2;
	processInputPackets( grandParentClasss_ac, jClasss_b0);
	if( false== _matches.empty())
		return true;
	return false;
}

bool Case_ab::isInputUnique( const Udm::Object& grandParentClass_ba, const Udm::Object& jClass_c3)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itGrandParentClass_bc= _grandParentClass_b6.begin(), itJClass_c5= _jClass_bf.begin(); itGrandParentClass_bc!= _grandParentClass_b6.end(), itJClass_c5!= _jClass_bf.end(); ++itGrandParentClass_bc, ++itJClass_c5)
	{
		if( ( *itGrandParentClass_bc== grandParentClass_ba)&& ( *itJClass_c5== jClass_c3))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_grandParentClass_b6.push_back( grandParentClass_ba);
		_jClass_bf.push_back( jClass_c3);
	}
	return isUnique;
}

void Case_ab::processInputPackets( const Packets_t& grandParentClasss_ac, const Packets_t& jClasss_b0)
{
	for( Packets_t::const_iterator itGrandParentClass_b7= grandParentClasss_ac.begin(), itJClass_c0= jClasss_b0.begin(); itGrandParentClass_b7!= grandParentClasss_ac.end(), itJClass_c0!= jClasss_b0.end(); ++itGrandParentClass_b7, ++itJClass_c0)
	{
		bool isUnique= isInputUnique( *itGrandParentClass_b7, *itJClass_c0);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itGrandParentClass_b7, *itJClass_c0);
	}
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		outputAppender( currMatch.grandParentClass_d5, currMatch.childClass_d7, currMatch.jClass_d8);
	}
}

bool Case_ab::patternMatcher( const Udm::Object& grandParentClass_b8, const Udm::Object& jClass_c1)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( grandParentClass_b8.type(), UMLModel::Class::meta))
			continue;
		UMLModel::Class grandParentClass_bd= UMLModel::Class::Cast( grandParentClass_b8);
		if( false== Uml::IsDerivedFrom( jClass_c1.type(), JavaModel::JClass::meta))
			continue;
		JavaModel::JClass jClass_c6= JavaModel::JClass::Cast( jClass_c1);
		set< JavaModel::JClass> jClasss_c8= grandParentClass_bd.dst();
		for( set< JavaModel::JClass>::const_iterator itJClasss_c9= jClasss_c8.begin(); itJClasss_c9!= jClasss_c8.end(); ++itJClasss_c9)
		{
			JavaModel::JClass currJClass_ca= *itJClasss_c9;
			if( jClass_c6!= currJClass_ca)
				continue;
			set< UMLModel::Inheritance> inheritances_cb= grandParentClass_bd.dstInheritance();
			for( set< UMLModel::Inheritance>::const_iterator itInheritances_cc= inheritances_cb.begin(); itInheritances_cc!= inheritances_cb.end(); ++itInheritances_cc)
			{
				UMLModel::Inheritance currInheritance_cd= *itInheritances_cc;
				UMLModel::Class parentClass_ce= currInheritance_cd.dstInheritance_end();
				set< UMLModel::Inheritance> inheritances_cf= parentClass_ce.dstInheritance();
				for( set< UMLModel::Inheritance>::const_iterator itInheritances_d0= inheritances_cf.begin(); itInheritances_d0!= inheritances_cf.end(); ++itInheritances_d0)
				{
					UMLModel::Inheritance currInheritance_d1= *itInheritances_d0;
					UMLModel::Class childClass_d2= currInheritance_d1.dstInheritance_end();
					Match currMatch;
					currMatch.inheritance_d3= currInheritance_d1;
					currMatch.inheritance_d4= currInheritance_cd;
					currMatch.grandParentClass_d5= grandParentClass_bd;
					currMatch.parentClass_d6= parentClass_ce;
					currMatch.childClass_d7= childClass_d2;
					currMatch.jClass_d8= jClass_c6;
					_matches.push_back( currMatch);
				}
			}
		}
	}
	return !_matches.empty();
}

void Case_ab::outputAppender( const UMLModel::Class& grandParentClass_d9, const UMLModel::Class& childClass_db, const JavaModel::JClass& jClass_dd)
{
	_grandParentClass_b3->push_back( grandParentClass_d9);
	_childClass_b4->push_back( childClass_db);
	_jClass_b5->push_back( jClass_dd);
}

void FirstRule_df::operator()( const Packets_t& rootFolders_e1, const Packets_t& rootFolders_e3, Packets_t& uMLs_e0, Packets_t& javas_e5)
{
#ifdef PRINT_INFO
	std::cout << "FirstRule_df" << std::endl;
#endif
	_uML_e6= &uMLs_e0;
	_java_e7= &javas_e5;
	processInputPackets( rootFolders_e1, rootFolders_e3);
}

bool FirstRule_df::isInputUnique( const Udm::Object& rootFolder_ec, const Udm::Object& rootFolder_f5)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_ee= _rootFolder_e8.begin(), itRootFolder_f7= _rootFolder_f1.begin(); itRootFolder_ee!= _rootFolder_e8.end(), itRootFolder_f7!= _rootFolder_f1.end(); ++itRootFolder_ee, ++itRootFolder_f7)
	{
		if( ( *itRootFolder_ee== rootFolder_ec)&& ( *itRootFolder_f7== rootFolder_f5))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_e8.push_back( rootFolder_ec);
		_rootFolder_f1.push_back( rootFolder_f5);
	}
	return isUnique;
}

void FirstRule_df::processInputPackets( const Packets_t& rootFolders_e1, const Packets_t& rootFolders_e3)
{
	for( Packets_t::const_iterator itRootFolder_e9= rootFolders_e1.begin(), itRootFolder_f2= rootFolders_e3.begin(); itRootFolder_e9!= rootFolders_e1.end(), itRootFolder_f2!= rootFolders_e3.end(); ++itRootFolder_e9, ++itRootFolder_f2)
	{
		bool isUnique= isInputUnique( *itRootFolder_e9, *itRootFolder_f2);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_e9, *itRootFolder_f2);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool FirstRule_df::patternMatcher( const Udm::Object& rootFolder_ea, const Udm::Object& rootFolder_f3)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_ea.type(), UMLModel::RootFolder::meta))
			continue;
		UMLModel::RootFolder rootFolder_ef= UMLModel::RootFolder::Cast( rootFolder_ea);
		if( false== Uml::IsDerivedFrom( rootFolder_f3.type(), JavaModel::RootFolder::meta))
			continue;
		JavaModel::RootFolder rootFolder_f8= JavaModel::RootFolder::Cast( rootFolder_f3);
		set< UMLModel::UML> uMLs_fa= rootFolder_ef.UML_kind_children();
		for( set< UMLModel::UML>::const_iterator itUML_fb= uMLs_fa.begin(); itUML_fb!= uMLs_fa.end(); ++itUML_fb)
		{
			UMLModel::UML currUML_fc= *itUML_fb;
			Match currMatch;
			currMatch.uML_fd= currUML_fc;
			currMatch.rootFolder_fe= rootFolder_ef;
			currMatch.rootFolder_ff= rootFolder_f8;
			_matches.push_back( currMatch);
		}
	}
	return !_matches.empty();
}

void FirstRule_df::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		JavaModel::Java newJava_100= JavaModel::Java::Create( currMatch.rootFolder_ff);
		outputAppender( currMatch.uML_fd, newJava_100);
	}
}

void FirstRule_df::outputAppender( const UMLModel::UML& uML_101, const JavaModel::Java& java_103)
{
	_uML_e6->push_back( uML_101);
	_java_e7->push_back( java_103);
}

void ThirdRule_105::operator()( const Packets_t& grandParentClasss_106, const Packets_t& myParentClasss_108, const Packets_t& childClasss_10a, const Packets_t& grandJClasss_10c, const Packets_t& abstractJClasss_10e)
{
#ifdef PRINT_INFO
	std::cout << "ThirdRule_105" << std::endl;
#endif
	processInputPackets( grandParentClasss_106, myParentClasss_108, childClasss_10a, grandJClasss_10c, abstractJClasss_10e);
}

bool ThirdRule_105::isInputUnique( const Udm::Object& grandParentClass_114, const Udm::Object& myParentClass_11d, const Udm::Object& childClass_126, const Udm::Object& grandJClass_12f, const Udm::Object& abstractJClass_138)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itGrandParentClass_116= _grandParentClass_110.begin(), itMyParentClass_11f= _myParentClass_119.begin(), itChildClass_128= _childClass_122.begin(), itGrandJClass_131= _grandJClass_12b.begin(), itAbstractJClass_13a= _abstractJClass_134.begin(); itGrandParentClass_116!= _grandParentClass_110.end(), itMyParentClass_11f!= _myParentClass_119.end(), itChildClass_128!= _childClass_122.end(), itGrandJClass_131!= _grandJClass_12b.end(), itAbstractJClass_13a!= _abstractJClass_134.end(); ++itGrandParentClass_116, ++itMyParentClass_11f, ++itChildClass_128, ++itGrandJClass_131, ++itAbstractJClass_13a)
	{
		if( ( *itGrandParentClass_116== grandParentClass_114)&& ( *itMyParentClass_11f== myParentClass_11d)&& ( *itChildClass_128== childClass_126)&& ( *itGrandJClass_131== grandJClass_12f)&& ( *itAbstractJClass_13a== abstractJClass_138))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_grandParentClass_110.push_back( grandParentClass_114);
		_myParentClass_119.push_back( myParentClass_11d);
		_childClass_122.push_back( childClass_126);
		_grandJClass_12b.push_back( grandJClass_12f);
		_abstractJClass_134.push_back( abstractJClass_138);
	}
	return isUnique;
}

void ThirdRule_105::processInputPackets( const Packets_t& grandParentClasss_106, const Packets_t& myParentClasss_108, const Packets_t& childClasss_10a, const Packets_t& grandJClasss_10c, const Packets_t& abstractJClasss_10e)
{
	for( Packets_t::const_iterator itGrandParentClass_111= grandParentClasss_106.begin(), itMyParentClass_11a= myParentClasss_108.begin(), itChildClass_123= childClasss_10a.begin(), itGrandJClass_12c= grandJClasss_10c.begin(), itAbstractJClass_135= abstractJClasss_10e.begin(); itGrandParentClass_111!= grandParentClasss_106.end(), itMyParentClass_11a!= myParentClasss_108.end(), itChildClass_123!= childClasss_10a.end(), itGrandJClass_12c!= grandJClasss_10c.end(), itAbstractJClass_135!= abstractJClasss_10e.end(); ++itGrandParentClass_111, ++itMyParentClass_11a, ++itChildClass_123, ++itGrandJClass_12c, ++itAbstractJClass_135)
	{
		bool isUnique= isInputUnique( *itGrandParentClass_111, *itMyParentClass_11a, *itChildClass_123, *itGrandJClass_12c, *itAbstractJClass_135);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itGrandParentClass_111, *itMyParentClass_11a, *itChildClass_123, *itGrandJClass_12c, *itAbstractJClass_135);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool ThirdRule_105::patternMatcher( const Udm::Object& grandParentClass_112, const Udm::Object& myParentClass_11b, const Udm::Object& childClass_124, const Udm::Object& grandJClass_12d, const Udm::Object& abstractJClass_136)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( grandParentClass_112.type(), UMLModel::Class::meta))
			continue;
		UMLModel::Class grandParentClass_117= UMLModel::Class::Cast( grandParentClass_112);
		if( false== Uml::IsDerivedFrom( myParentClass_11b.type(), UMLModel::Class::meta))
			continue;
		UMLModel::Class myParentClass_120= UMLModel::Class::Cast( myParentClass_11b);
		if( false== Uml::IsDerivedFrom( childClass_124.type(), UMLModel::Class::meta))
			continue;
		UMLModel::Class childClass_129= UMLModel::Class::Cast( childClass_124);
		if( false== Uml::IsDerivedFrom( grandJClass_12d.type(), JavaModel::JClass::meta))
			continue;
		JavaModel::JClass grandJClass_132= JavaModel::JClass::Cast( grandJClass_12d);
		if( false== Uml::IsDerivedFrom( abstractJClass_136.type(), JavaModel::JClass::meta))
			continue;
		JavaModel::JClass abstractJClass_13b= JavaModel::JClass::Cast( abstractJClass_136);
		set< JavaModel::JClass> grandJClasss_13d= grandParentClass_117.dst();
		for( set< JavaModel::JClass>::const_iterator itGrandJClasss_13e= grandJClasss_13d.begin(); itGrandJClasss_13e!= grandJClasss_13d.end(); ++itGrandJClasss_13e)
		{
			JavaModel::JClass currGrandJClass_13f= *itGrandJClasss_13e;
			if( grandJClass_132!= currGrandJClass_13f)
				continue;
			set< UMLModel::Inheritance> inheritances_140= grandParentClass_117.dstInheritance();
			for( set< UMLModel::Inheritance>::const_iterator itInheritances_141= inheritances_140.begin(); itInheritances_141!= inheritances_140.end(); ++itInheritances_141)
			{
				UMLModel::Inheritance currInheritance_142= *itInheritances_141;
				UMLModel::Class myParentClass_143= currInheritance_142.dstInheritance_end();
				if( myParentClass_120!= myParentClass_143)
					continue;
				set< UMLModel::Inheritance> inheritances_144= grandParentClass_117.dstInheritance();
				for( set< UMLModel::Inheritance>::const_iterator itInheritances_145= inheritances_144.begin(); itInheritances_145!= inheritances_144.end(); ++itInheritances_145)
				{
					UMLModel::Inheritance currInheritance_146= *itInheritances_145;
					// Simple association identity check.
					if( ( currInheritance_142!= currInheritance_146))
					{
						UMLModel::Class parentClass_147= currInheritance_146.dstInheritance_end();
						set< JavaModel::JClass> concreteDiscriminatedJClasss_148= parentClass_147.dst();
						for( set< JavaModel::JClass>::const_iterator itConcreteDiscriminatedJClasss_149= concreteDiscriminatedJClasss_148.begin(); itConcreteDiscriminatedJClasss_149!= concreteDiscriminatedJClasss_148.end(); ++itConcreteDiscriminatedJClasss_149)
						{
							JavaModel::JClass currConcreteDiscriminatedJClass_14a= *itConcreteDiscriminatedJClasss_149;
							Udm::Object concreteDiscriminatedJClassParent_14b= currConcreteDiscriminatedJClass_14a.container();
							if( false== Uml::IsDerivedFrom( concreteDiscriminatedJClassParent_14b.type(), JavaModel::Java::meta))
								continue;
							JavaModel::Java javaConcreteDiscriminatedJClass_14c= JavaModel::Java::Cast( concreteDiscriminatedJClassParent_14b);
							set< UMLModel::Inheritance> inheritances_14d= myParentClass_120.dstInheritance();
							for( set< UMLModel::Inheritance>::const_iterator itInheritances_14e= inheritances_14d.begin(); itInheritances_14e!= inheritances_14d.end(); ++itInheritances_14e)
							{
								UMLModel::Inheritance currInheritance_14f= *itInheritances_14e;
								UMLModel::Class childClass_150= currInheritance_14f.dstInheritance_end();
								if( childClass_129!= childClass_150)
									continue;
								set< JavaModel::JAgregation> jAgregations_151= grandJClass_132.dstJAgregation();
								for( set< JavaModel::JAgregation>::const_iterator itJAgregations_152= jAgregations_151.begin(); itJAgregations_152!= jAgregations_151.end(); ++itJAgregations_152)
								{
									JavaModel::JAgregation currJAgregation_153= *itJAgregations_152;
									JavaModel::JClass abstractJClass_154= currJAgregation_153.dstJAgregation_end();
									if( abstractJClass_13b!= abstractJClass_154)
										continue;
									set< UMLModel::Inheritance> inheritances_155= parentClass_147.dstInheritance();
									for( set< UMLModel::Inheritance>::const_iterator itInheritances_156= inheritances_155.begin(); itInheritances_156!= inheritances_155.end(); ++itInheritances_156)
									{
										UMLModel::Inheritance currInheritance_157= *itInheritances_156;
										UMLModel::Class childClass_158= currInheritance_157.dstInheritance_end();
										if( childClass_129!= childClass_158)
											continue;
										Match currMatch;
										currMatch.inheritance_159= currInheritance_14f;
										currMatch.inheritance_15a= currInheritance_142;
										currMatch.grandParentClass_15b= grandParentClass_117;
										currMatch.myParentClass_15c= myParentClass_120;
										currMatch.childClass_15d= childClass_129;
										currMatch.inheritance_15e= currInheritance_146;
										currMatch.inheritance_15f= currInheritance_157;
										currMatch.parentClass_160= parentClass_147;
										currMatch.concreteDiscriminatedJClass_161= currConcreteDiscriminatedJClass_14a;
										currMatch.grandJClass_162= grandJClass_132;
										currMatch.abstractJClass_163= abstractJClass_13b;
										currMatch.jAgregation_164= currJAgregation_153;
										currMatch.java_165= javaConcreteDiscriminatedJClass_14c;
										_matches.push_back( currMatch);
									}
								}
							}
						}
					}
				}
			}
		}
	}
	return !_matches.empty();
}

void ThirdRule_105::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		JavaModel::JInheritance newJInheritance_166= JavaModel::JInheritance::Create( currMatch.java_165);
		newJInheritance_166.srcJInheritance_end()= currMatch.abstractJClass_163;
		newJInheritance_166.dstJInheritance_end()= currMatch.concreteDiscriminatedJClass_161;
	}
}

