/* GenMI2SI.h generated on Wed Dec 07 13:18:05 2005
 */

#include <UdmBase.h>
#include <cint_string.h>
#include "JavaModel.h"
#include "MI2SI.h"
#include "UMLModel.h"

typedef std::list< Udm::Object> Packets_t;

// Forward declarations.
class NewBlock_0;
class CopyClasses_5;
class SecondRule_2b;
class Test_92;
class Case_ab;
class FirstRule_df;
class ThirdRule_105;

// Class declarations.
class NewBlock_0
{
public:
	void operator()( const Packets_t& javaIns_1, const Packets_t& uMLIns_3);

protected:
	void callFirstRule_167( const Packets_t& rootFolders_e1, const Packets_t& rootFolders_e3);
	void callCopyClasses_16a( const Packets_t& uMLs_7, const Packets_t& javas_9);
	void callTest_16d( const Packets_t& javaIns_93, const Packets_t& uMLIns_95);
	void callSecondRule_170( const Packets_t& grandParentClasss_2d, const Packets_t& childClasss_30, const Packets_t& grandParentJClasss_33);
	void callThirdRule_174( const Packets_t& grandParentClasss_106, const Packets_t& myParentClasss_108, const Packets_t& childClasss_10a, const Packets_t& grandJClasss_10c, const Packets_t& abstractJClasss_10e);
};

class CopyClasses_5
{
public:
	void operator()( const Packets_t& uMLs_7, const Packets_t& javas_9, Packets_t& classs_6, Packets_t& jClasss_b);

protected:
	bool isInputUnique( const Udm::Object& uML_12, const Udm::Object& java_1b);
	void processInputPackets( const Packets_t& uMLs_7, const Packets_t& javas_9);
	bool patternMatcher( const Udm::Object& uML_10, const Udm::Object& java_19);
	void effector();
	void outputAppender( const UMLModel::Class& class_27, const JavaModel::JClass& jClass_29);

private:
	Packets_t* _class_c;
	Packets_t* _jClass_d;
	Packets_t _uML_e;
	Packets_t _java_17;
	class Match
	{
	public:
		UMLModel::Class class_23;
		UMLModel::UML uML_24;
		JavaModel::Java java_25;
	};

	std::list< Match> _matches;
};

class SecondRule_2b
{
public:
	void operator()( const Packets_t& grandParentClasss_2d, const Packets_t& childClasss_30, const Packets_t& grandParentJClasss_33, Packets_t& myParentClasss_2c, Packets_t& grandParentClasss_2f, Packets_t& childClasss_32, Packets_t& grandParentJClasss_35, Packets_t& abstractJClasss_36);

protected:
	bool isInputUnique( const Udm::Object& grandParentClass_40, const Udm::Object& childClass_49, const Udm::Object& grandParentJClass_52);
	void processInputPackets( const Packets_t& grandParentClasss_2d, const Packets_t& childClasss_30, const Packets_t& grandParentJClasss_33);
	bool patternMatcher( const Udm::Object& grandParentClass_3e, const Udm::Object& childClass_47, const Udm::Object& grandParentJClass_50);
	void effector();
	void outputAppender( const UMLModel::Class& myParentClass_88, const UMLModel::Class& grandParentClass_8a, const UMLModel::Class& childClass_8c, const JavaModel::JClass& grandParentJClass_8e, const JavaModel::JClass& abstractJClass_90);

private:
	Packets_t* _myParentClass_37;
	Packets_t* _grandParentClass_38;
	Packets_t* _childClass_39;
	Packets_t* _grandParentJClass_3a;
	Packets_t* _abstractJClass_3b;
	Packets_t _grandParentClass_3c;
	Packets_t _childClass_45;
	Packets_t _grandParentJClass_4e;
	class Match
	{
	public:
		UMLModel::Inheritance inheritance_78;
		UMLModel::Class myParentClass_79;
		UMLModel::Inheritance inheritance_7a;
		UMLModel::Class grandParentClass_7b;
		UMLModel::Class parentClass_7c;
		UMLModel::Class childClass_7d;
		UMLModel::Inheritance inheritance_7e;
		UMLModel::Inheritance inheritance_7f;
		JavaModel::JClass grandParentJClass_80;
		JavaModel::JClass myParentJClass_81;
		JavaModel::JClass childJClass_82;
		JavaModel::Java java_83;
	};

	std::list< Match> _matches;
};

class Test_92
{
public:
	void operator()( const Packets_t& javaIns_93, const Packets_t& uMLIns_95, Packets_t& grandParentOuts_97, Packets_t& childOuts_98, Packets_t& javaOuts_99);

protected:
	void executeOne( const Packets_t& javaIns_93, const Packets_t& uMLIns_95);
	bool isInputUnique( const Udm::Object& javaIn_9f, const Udm::Object& uMLIn_a6);

private:
	Packets_t* _grandParentOut_9a;
	Packets_t* _childOut_9b;
	Packets_t* _javaOut_9c;
	Packets_t _javaIn_9d;
	Packets_t _uMLIn_a4;
};

class Case_ab
{
public:
	bool operator()( const Packets_t& grandParentClasss_ac, const Packets_t& jClasss_b0, Packets_t& grandParentClasss_ae, Packets_t& childClasss_af, Packets_t& jClasss_b2);

protected:
	bool isInputUnique( const Udm::Object& grandParentClass_ba, const Udm::Object& jClass_c3);
	void processInputPackets( const Packets_t& grandParentClasss_ac, const Packets_t& jClasss_b0);
	bool patternMatcher( const Udm::Object& grandParentClass_b8, const Udm::Object& jClass_c1);
	void outputAppender( const UMLModel::Class& grandParentClass_d9, const UMLModel::Class& childClass_db, const JavaModel::JClass& jClass_dd);

private:
	Packets_t* _grandParentClass_b3;
	Packets_t* _childClass_b4;
	Packets_t* _jClass_b5;
	Packets_t _grandParentClass_b6;
	Packets_t _jClass_bf;
	class Match
	{
	public:
		UMLModel::Inheritance inheritance_d3;
		UMLModel::Inheritance inheritance_d4;
		UMLModel::Class grandParentClass_d5;
		UMLModel::Class parentClass_d6;
		UMLModel::Class childClass_d7;
		JavaModel::JClass jClass_d8;
	};

	std::list< Match> _matches;
};

class FirstRule_df
{
public:
	void operator()( const Packets_t& rootFolders_e1, const Packets_t& rootFolders_e3, Packets_t& uMLs_e0, Packets_t& javas_e5);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_ec, const Udm::Object& rootFolder_f5);
	void processInputPackets( const Packets_t& rootFolders_e1, const Packets_t& rootFolders_e3);
	bool patternMatcher( const Udm::Object& rootFolder_ea, const Udm::Object& rootFolder_f3);
	void effector();
	void outputAppender( const UMLModel::UML& uML_101, const JavaModel::Java& java_103);

private:
	Packets_t* _uML_e6;
	Packets_t* _java_e7;
	Packets_t _rootFolder_e8;
	Packets_t _rootFolder_f1;
	class Match
	{
	public:
		UMLModel::UML uML_fd;
		UMLModel::RootFolder rootFolder_fe;
		JavaModel::RootFolder rootFolder_ff;
	};

	std::list< Match> _matches;
};

class ThirdRule_105
{
public:
	void operator()( const Packets_t& grandParentClasss_106, const Packets_t& myParentClasss_108, const Packets_t& childClasss_10a, const Packets_t& grandJClasss_10c, const Packets_t& abstractJClasss_10e);

protected:
	bool isInputUnique( const Udm::Object& grandParentClass_114, const Udm::Object& myParentClass_11d, const Udm::Object& childClass_126, const Udm::Object& grandJClass_12f, const Udm::Object& abstractJClass_138);
	void processInputPackets( const Packets_t& grandParentClasss_106, const Packets_t& myParentClasss_108, const Packets_t& childClasss_10a, const Packets_t& grandJClasss_10c, const Packets_t& abstractJClasss_10e);
	bool patternMatcher( const Udm::Object& grandParentClass_112, const Udm::Object& myParentClass_11b, const Udm::Object& childClass_124, const Udm::Object& grandJClass_12d, const Udm::Object& abstractJClass_136);
	void effector();

private:
	Packets_t _grandParentClass_110;
	Packets_t _myParentClass_119;
	Packets_t _childClass_122;
	Packets_t _grandJClass_12b;
	Packets_t _abstractJClass_134;
	class Match
	{
	public:
		UMLModel::Inheritance inheritance_159;
		UMLModel::Inheritance inheritance_15a;
		UMLModel::Class grandParentClass_15b;
		UMLModel::Class myParentClass_15c;
		UMLModel::Class childClass_15d;
		UMLModel::Inheritance inheritance_15e;
		UMLModel::Inheritance inheritance_15f;
		UMLModel::Class parentClass_160;
		JavaModel::JClass concreteDiscriminatedJClass_161;
		JavaModel::JClass grandJClass_162;
		JavaModel::JClass abstractJClass_163;
		JavaModel::JAgregation jAgregation_164;
		JavaModel::Java java_165;
	};

	std::list< Match> _matches;
};

