#ifndef MOBIES_JAVAMODEL_H
#define MOBIES_JAVAMODEL_H
// header file JavaModel.h generated from diagram JavaModel
// generated on Fri Feb 03 09:37:39 2006

#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif

namespace UMLModel
{ 
	 class  Inheritance;
	 class  Class;
};


namespace JavaModel {

	class  JInheritance;
	class  JClassHasJFeature;
	class  JAgregation;
	class  Field;
	class  Method;
	class  JFeature;
	class  Java;
	class  JClass;
	class  RootFolder;
	class  MgaObject;

	  void Initialize();

	  void Initialize(const Uml::Diagram &dgr);
	extern  Udm::UdmDiagram diagram;

	class  RootFolder :  public Udm::Object
	{
	 public:
		static Uml::Class meta;

		RootFolder() { }
		RootFolder(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) { }
		RootFolder(const RootFolder &master) : UDM_OBJECT(master) { }
		static RootFolder Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static RootFolder Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		RootFolder CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		RootFolder CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<RootFolder> Instances() { return Udm::InstantiatedAttr<JavaModel::RootFolder>(impl);}
		template <class Pred> Udm::InstantiatedAttr<RootFolder, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<JavaModel::RootFolder, Pred>(impl);}

		Udm::DerivedAttr<JavaModel::RootFolder> Derived() { return Udm::DerivedAttr<JavaModel::RootFolder>(impl);}
		template <class Pred> Udm::DerivedAttr<JavaModel::RootFolder, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<JavaModel::RootFolder, Pred>(impl);}

		Udm::ArchetypeAttr<JavaModel::RootFolder> Archetype() { return Udm::ArchetypeAttr<JavaModel::RootFolder>(impl);}

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::CompositionChildRole meta_RootFolder_children;
		Udm::ChildrenAttr<JavaModel::RootFolder> RootFolder_children() const { return Udm::ChildrenAttr<JavaModel::RootFolder>(impl, meta_RootFolder_children); }
		 template <class Pred> Udm::ChildrenAttr<JavaModel::RootFolder, Pred> RootFolder_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::RootFolder, Pred>(impl, meta_RootFolder_children); }

		static Uml::CompositionChildRole meta_Java_children;
		Udm::ChildrenAttr<JavaModel::Java> Java_children() const { return Udm::ChildrenAttr<JavaModel::Java>(impl, meta_Java_children); }
		 template <class Pred> Udm::ChildrenAttr<JavaModel::Java, Pred> Java_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::Java, Pred>(impl, meta_Java_children); }

		Udm::ChildrenAttr<JavaModel::Java> Java_kind_children() const { return Udm::ChildrenAttr<JavaModel::Java>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<JavaModel::Java, Pred> Java_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::Java, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<JavaModel::RootFolder> RootFolder_kind_children() const { return Udm::ChildrenAttr<JavaModel::RootFolder>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<JavaModel::RootFolder, Pred> RootFolder_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::RootFolder, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<JavaModel::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<JavaModel::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<JavaModel::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<JavaModel::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<JavaModel::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<JavaModel::RootFolder> parent() const { return Udm::ParentAttr<JavaModel::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

	class  MgaObject :  public Udm::Object
	{
	 public:
		static Uml::Class meta;

		MgaObject() { }
		MgaObject(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) { }
		MgaObject(const MgaObject &master) : UDM_OBJECT(master) { }
		static MgaObject Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static MgaObject Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		MgaObject CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		MgaObject CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<MgaObject> Instances() { return Udm::InstantiatedAttr<JavaModel::MgaObject>(impl);}
		template <class Pred> Udm::InstantiatedAttr<MgaObject, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<JavaModel::MgaObject, Pred>(impl);}

		Udm::DerivedAttr<JavaModel::MgaObject> Derived() { return Udm::DerivedAttr<JavaModel::MgaObject>(impl);}
		template <class Pred> Udm::DerivedAttr<JavaModel::MgaObject, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<JavaModel::MgaObject, Pred>(impl);}

		Udm::ArchetypeAttr<JavaModel::MgaObject> Archetype() { return Udm::ArchetypeAttr<JavaModel::MgaObject>(impl);}

		static Uml::Attribute meta_position;
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  JInheritance :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		JInheritance() { }
		JInheritance(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		JInheritance(const JInheritance &master) : MgaObject(master) { }
		static JInheritance Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static JInheritance Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		JInheritance CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		JInheritance CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<JInheritance> Instances() { return Udm::InstantiatedAttr<JavaModel::JInheritance>(impl);}
		template <class Pred> Udm::InstantiatedAttr<JInheritance, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<JavaModel::JInheritance, Pred>(impl);}

		Udm::DerivedAttr<JavaModel::JInheritance> Derived() { return Udm::DerivedAttr<JavaModel::JInheritance>(impl);}
		template <class Pred> Udm::DerivedAttr<JavaModel::JInheritance, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<JavaModel::JInheritance, Pred>(impl);}

		Udm::ArchetypeAttr<JavaModel::JInheritance> Archetype() { return Udm::ArchetypeAttr<JavaModel::JInheritance>(impl);}

		static Uml::AssociationRole meta_src;
		Udm::CrossAssocAttr<UMLModel::Inheritance> src() const { return Udm::CrossAssocAttr<UMLModel::Inheritance>(impl, meta_src); }
		template<class Pred> Udm::CrossAssocAttr<UMLModel::Inheritance, Pred> src_sorted(const Pred &) const { return Udm::CrossAssocAttr<UMLModel::Inheritance, Pred>(impl, meta_src); }

		static Uml::CompositionParentRole meta_Java_parent;
		Udm::ParentAttr<JavaModel::Java> Java_parent() const { return Udm::ParentAttr<JavaModel::Java>(impl, meta_Java_parent); }

		Udm::ParentAttr<JavaModel::MgaObject> parent() const { return Udm::ParentAttr<JavaModel::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dstJInheritance_end_;
		Udm::AssocEndAttr<JavaModel::JClass> dstJInheritance_end() const { return Udm::AssocEndAttr<JavaModel::JClass>(impl, meta_dstJInheritance_end_); }

		static Uml::AssociationRole meta_srcJInheritance_end_;
		Udm::AssocEndAttr<JavaModel::JClass> srcJInheritance_end() const { return Udm::AssocEndAttr<JavaModel::JClass>(impl, meta_srcJInheritance_end_); }

	};

	class  JClassHasJFeature :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		JClassHasJFeature() { }
		JClassHasJFeature(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		JClassHasJFeature(const JClassHasJFeature &master) : MgaObject(master) { }
		static JClassHasJFeature Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static JClassHasJFeature Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		JClassHasJFeature CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		JClassHasJFeature CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<JClassHasJFeature> Instances() { return Udm::InstantiatedAttr<JavaModel::JClassHasJFeature>(impl);}
		template <class Pred> Udm::InstantiatedAttr<JClassHasJFeature, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<JavaModel::JClassHasJFeature, Pred>(impl);}

		Udm::DerivedAttr<JavaModel::JClassHasJFeature> Derived() { return Udm::DerivedAttr<JavaModel::JClassHasJFeature>(impl);}
		template <class Pred> Udm::DerivedAttr<JavaModel::JClassHasJFeature, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<JavaModel::JClassHasJFeature, Pred>(impl);}

		Udm::ArchetypeAttr<JavaModel::JClassHasJFeature> Archetype() { return Udm::ArchetypeAttr<JavaModel::JClassHasJFeature>(impl);}

		static Uml::CompositionParentRole meta_Java_parent;
		Udm::ParentAttr<JavaModel::Java> Java_parent() const { return Udm::ParentAttr<JavaModel::Java>(impl, meta_Java_parent); }

		Udm::ParentAttr<JavaModel::MgaObject> parent() const { return Udm::ParentAttr<JavaModel::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dstJClassHasJFeature_end_;
		Udm::AssocEndAttr<JavaModel::JFeature> dstJClassHasJFeature_end() const { return Udm::AssocEndAttr<JavaModel::JFeature>(impl, meta_dstJClassHasJFeature_end_); }

		static Uml::AssociationRole meta_srcJClassHasJFeature_end_;
		Udm::AssocEndAttr<JavaModel::JClass> srcJClassHasJFeature_end() const { return Udm::AssocEndAttr<JavaModel::JClass>(impl, meta_srcJClassHasJFeature_end_); }

	};

	class  JAgregation :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		JAgregation() { }
		JAgregation(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		JAgregation(const JAgregation &master) : MgaObject(master) { }
		static JAgregation Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static JAgregation Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		JAgregation CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		JAgregation CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<JAgregation> Instances() { return Udm::InstantiatedAttr<JavaModel::JAgregation>(impl);}
		template <class Pred> Udm::InstantiatedAttr<JAgregation, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<JavaModel::JAgregation, Pred>(impl);}

		Udm::DerivedAttr<JavaModel::JAgregation> Derived() { return Udm::DerivedAttr<JavaModel::JAgregation>(impl);}
		template <class Pred> Udm::DerivedAttr<JavaModel::JAgregation, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<JavaModel::JAgregation, Pred>(impl);}

		Udm::ArchetypeAttr<JavaModel::JAgregation> Archetype() { return Udm::ArchetypeAttr<JavaModel::JAgregation>(impl);}

		static Uml::CompositionParentRole meta_Java_parent;
		Udm::ParentAttr<JavaModel::Java> Java_parent() const { return Udm::ParentAttr<JavaModel::Java>(impl, meta_Java_parent); }

		Udm::ParentAttr<JavaModel::MgaObject> parent() const { return Udm::ParentAttr<JavaModel::MgaObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dstJAgregation_end_;
		Udm::AssocEndAttr<JavaModel::JClass> dstJAgregation_end() const { return Udm::AssocEndAttr<JavaModel::JClass>(impl, meta_dstJAgregation_end_); }

		static Uml::AssociationRole meta_srcJAgregation_end_;
		Udm::AssocEndAttr<JavaModel::JClass> srcJAgregation_end() const { return Udm::AssocEndAttr<JavaModel::JClass>(impl, meta_srcJAgregation_end_); }

	};

	class  Field :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		Field() { }
		Field(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Field(const Field &master) : MgaObject(master) { }
		static Field Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Field Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Field CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Field CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Field> Instances() { return Udm::InstantiatedAttr<JavaModel::Field>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Field, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<JavaModel::Field, Pred>(impl);}

		Udm::DerivedAttr<JavaModel::Field> Derived() { return Udm::DerivedAttr<JavaModel::Field>(impl);}
		template <class Pred> Udm::DerivedAttr<JavaModel::Field, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<JavaModel::Field, Pred>(impl);}

		Udm::ArchetypeAttr<JavaModel::Field> Archetype() { return Udm::ArchetypeAttr<JavaModel::Field>(impl);}

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  Method :  public Field
	{
	 public:
		static Uml::Class meta;

		Method() { }
		Method(Udm::ObjectImpl *impl) : Field(impl) { }
		Method(const Method &master) : Field(master) { }
		static Method Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Method Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Method CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Method CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Method> Instances() { return Udm::InstantiatedAttr<JavaModel::Method>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Method, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<JavaModel::Method, Pred>(impl);}

		Udm::DerivedAttr<JavaModel::Method> Derived() { return Udm::DerivedAttr<JavaModel::Method>(impl);}
		template <class Pred> Udm::DerivedAttr<JavaModel::Method, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<JavaModel::Method, Pred>(impl);}

		Udm::ArchetypeAttr<JavaModel::Method> Archetype() { return Udm::ArchetypeAttr<JavaModel::Method>(impl);}

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  JFeature :  public Field
	{
	 public:
		static Uml::Class meta;

		JFeature() { }
		JFeature(Udm::ObjectImpl *impl) : Field(impl) { }
		JFeature(const JFeature &master) : Field(master) { }
		static JFeature Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static JFeature Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		JFeature CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		JFeature CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<JFeature> Instances() { return Udm::InstantiatedAttr<JavaModel::JFeature>(impl);}
		template <class Pred> Udm::InstantiatedAttr<JFeature, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<JavaModel::JFeature, Pred>(impl);}

		Udm::DerivedAttr<JavaModel::JFeature> Derived() { return Udm::DerivedAttr<JavaModel::JFeature>(impl);}
		template <class Pred> Udm::DerivedAttr<JavaModel::JFeature, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<JavaModel::JFeature, Pred>(impl);}

		Udm::ArchetypeAttr<JavaModel::JFeature> Archetype() { return Udm::ArchetypeAttr<JavaModel::JFeature>(impl);}

		static Uml::AssociationRole meta_srcJClassHasJFeature;
		static Uml::AssociationRole meta_srcJClassHasJFeature_rev;
		Udm::AClassAssocAttr<JavaModel::JClassHasJFeature, JavaModel::JClass> srcJClassHasJFeature() const { return Udm::AClassAssocAttr<JavaModel::JClassHasJFeature, JavaModel::JClass>(impl, meta_srcJClassHasJFeature, meta_srcJClassHasJFeature_rev); }
		template<class Pred> Udm::AClassAssocAttr<JavaModel::JClassHasJFeature, JavaModel::JClass, Pred> srcJClassHasJFeature_sorted(const Pred &) const { return Udm::AClassAssocAttr<JavaModel::JClassHasJFeature, JavaModel::JClass, Pred>(impl, meta_srcJClassHasJFeature, meta_srcJClassHasJFeature_rev); }

		static Uml::CompositionParentRole meta_Java_parent;
		Udm::ParentAttr<JavaModel::Java> Java_parent() const { return Udm::ParentAttr<JavaModel::Java>(impl, meta_Java_parent); }

		Udm::ParentAttr<JavaModel::MgaObject> parent() const { return Udm::ParentAttr<JavaModel::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

	class  Java :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		Java() { }
		Java(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		Java(const Java &master) : MgaObject(master) { }
		static Java Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Java Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Java CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Java CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Java> Instances() { return Udm::InstantiatedAttr<JavaModel::Java>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Java, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<JavaModel::Java, Pred>(impl);}

		Udm::DerivedAttr<JavaModel::Java> Derived() { return Udm::DerivedAttr<JavaModel::Java>(impl);}
		template <class Pred> Udm::DerivedAttr<JavaModel::Java, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<JavaModel::Java, Pred>(impl);}

		Udm::ArchetypeAttr<JavaModel::Java> Archetype() { return Udm::ArchetypeAttr<JavaModel::Java>(impl);}

		static Uml::CompositionChildRole meta_JFeature_children;
		Udm::ChildrenAttr<JavaModel::JFeature> JFeature_children() const { return Udm::ChildrenAttr<JavaModel::JFeature>(impl, meta_JFeature_children); }
		 template <class Pred> Udm::ChildrenAttr<JavaModel::JFeature, Pred> JFeature_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::JFeature, Pred>(impl, meta_JFeature_children); }

		static Uml::CompositionChildRole meta_JClassHasJFeature_children;
		Udm::ChildrenAttr<JavaModel::JClassHasJFeature> JClassHasJFeature_children() const { return Udm::ChildrenAttr<JavaModel::JClassHasJFeature>(impl, meta_JClassHasJFeature_children); }
		 template <class Pred> Udm::ChildrenAttr<JavaModel::JClassHasJFeature, Pred> JClassHasJFeature_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::JClassHasJFeature, Pred>(impl, meta_JClassHasJFeature_children); }

		static Uml::CompositionChildRole meta_JAgregation_children;
		Udm::ChildrenAttr<JavaModel::JAgregation> JAgregation_children() const { return Udm::ChildrenAttr<JavaModel::JAgregation>(impl, meta_JAgregation_children); }
		 template <class Pred> Udm::ChildrenAttr<JavaModel::JAgregation, Pred> JAgregation_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::JAgregation, Pred>(impl, meta_JAgregation_children); }

		static Uml::CompositionChildRole meta_JInheritance_children;
		Udm::ChildrenAttr<JavaModel::JInheritance> JInheritance_children() const { return Udm::ChildrenAttr<JavaModel::JInheritance>(impl, meta_JInheritance_children); }
		 template <class Pred> Udm::ChildrenAttr<JavaModel::JInheritance, Pred> JInheritance_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::JInheritance, Pred>(impl, meta_JInheritance_children); }

		static Uml::CompositionChildRole meta_JClass_children;
		Udm::ChildrenAttr<JavaModel::JClass> JClass_children() const { return Udm::ChildrenAttr<JavaModel::JClass>(impl, meta_JClass_children); }
		 template <class Pred> Udm::ChildrenAttr<JavaModel::JClass, Pred> JClass_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::JClass, Pred>(impl, meta_JClass_children); }

		Udm::ChildrenAttr<JavaModel::JInheritance> JInheritance_kind_children() const { return Udm::ChildrenAttr<JavaModel::JInheritance>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<JavaModel::JInheritance, Pred> JInheritance_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::JInheritance, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<JavaModel::JClassHasJFeature> JClassHasJFeature_kind_children() const { return Udm::ChildrenAttr<JavaModel::JClassHasJFeature>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<JavaModel::JClassHasJFeature, Pred> JClassHasJFeature_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::JClassHasJFeature, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<JavaModel::JAgregation> JAgregation_kind_children() const { return Udm::ChildrenAttr<JavaModel::JAgregation>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<JavaModel::JAgregation, Pred> JAgregation_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::JAgregation, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<JavaModel::Field> Field_kind_children() const { return Udm::ChildrenAttr<JavaModel::Field>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<JavaModel::Field, Pred> Field_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::Field, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<JavaModel::JFeature> JFeature_kind_children() const { return Udm::ChildrenAttr<JavaModel::JFeature>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<JavaModel::JFeature, Pred> JFeature_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::JFeature, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<JavaModel::JClass> JClass_kind_children() const { return Udm::ChildrenAttr<JavaModel::JClass>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<JavaModel::JClass, Pred> JClass_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::JClass, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<JavaModel::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr<JavaModel::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<JavaModel::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<JavaModel::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<JavaModel::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<JavaModel::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<JavaModel::RootFolder> parent() const { return Udm::ParentAttr<JavaModel::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

	class  JClass :  public MgaObject
	{
	 public:
		static Uml::Class meta;

		JClass() { }
		JClass(Udm::ObjectImpl *impl) : MgaObject(impl) { }
		JClass(const JClass &master) : MgaObject(master) { }
		static JClass Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static JClass Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		JClass CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		JClass CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<JClass> Instances() { return Udm::InstantiatedAttr<JavaModel::JClass>(impl);}
		template <class Pred> Udm::InstantiatedAttr<JClass, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<JavaModel::JClass, Pred>(impl);}

		Udm::DerivedAttr<JavaModel::JClass> Derived() { return Udm::DerivedAttr<JavaModel::JClass>(impl);}
		template <class Pred> Udm::DerivedAttr<JavaModel::JClass, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<JavaModel::JClass, Pred>(impl);}

		Udm::ArchetypeAttr<JavaModel::JClass> Archetype() { return Udm::ArchetypeAttr<JavaModel::JClass>(impl);}

		static Uml::AssociationRole meta_srcJInheritance;
		static Uml::AssociationRole meta_srcJInheritance_rev;
		Udm::AClassPointerAttr<JavaModel::JInheritance, JavaModel::JClass> srcJInheritance() const { return Udm::AClassPointerAttr<JavaModel::JInheritance, JavaModel::JClass>(impl, meta_srcJInheritance, meta_srcJInheritance_rev); }

		static Uml::AssociationRole meta_dstJInheritance;
		static Uml::AssociationRole meta_dstJInheritance_rev;
		Udm::AClassAssocAttr<JavaModel::JInheritance, JavaModel::JClass> dstJInheritance() const { return Udm::AClassAssocAttr<JavaModel::JInheritance, JavaModel::JClass>(impl, meta_dstJInheritance, meta_dstJInheritance_rev); }
		template<class Pred> Udm::AClassAssocAttr<JavaModel::JInheritance, JavaModel::JClass, Pred> dstJInheritance_sorted(const Pred &) const { return Udm::AClassAssocAttr<JavaModel::JInheritance, JavaModel::JClass, Pred>(impl, meta_dstJInheritance, meta_dstJInheritance_rev); }

		static Uml::AssociationRole meta_dstJClassHasJFeature;
		static Uml::AssociationRole meta_dstJClassHasJFeature_rev;
		Udm::AClassAssocAttr<JavaModel::JClassHasJFeature, JavaModel::JFeature> dstJClassHasJFeature() const { return Udm::AClassAssocAttr<JavaModel::JClassHasJFeature, JavaModel::JFeature>(impl, meta_dstJClassHasJFeature, meta_dstJClassHasJFeature_rev); }
		template<class Pred> Udm::AClassAssocAttr<JavaModel::JClassHasJFeature, JavaModel::JFeature, Pred> dstJClassHasJFeature_sorted(const Pred &) const { return Udm::AClassAssocAttr<JavaModel::JClassHasJFeature, JavaModel::JFeature, Pred>(impl, meta_dstJClassHasJFeature, meta_dstJClassHasJFeature_rev); }

		static Uml::AssociationRole meta_srcJAgregation;
		static Uml::AssociationRole meta_srcJAgregation_rev;
		Udm::AClassAssocAttr<JavaModel::JAgregation, JavaModel::JClass> srcJAgregation() const { return Udm::AClassAssocAttr<JavaModel::JAgregation, JavaModel::JClass>(impl, meta_srcJAgregation, meta_srcJAgregation_rev); }
		template<class Pred> Udm::AClassAssocAttr<JavaModel::JAgregation, JavaModel::JClass, Pred> srcJAgregation_sorted(const Pred &) const { return Udm::AClassAssocAttr<JavaModel::JAgregation, JavaModel::JClass, Pred>(impl, meta_srcJAgregation, meta_srcJAgregation_rev); }

		static Uml::AssociationRole meta_dstJAgregation;
		static Uml::AssociationRole meta_dstJAgregation_rev;
		Udm::AClassAssocAttr<JavaModel::JAgregation, JavaModel::JClass> dstJAgregation() const { return Udm::AClassAssocAttr<JavaModel::JAgregation, JavaModel::JClass>(impl, meta_dstJAgregation, meta_dstJAgregation_rev); }
		template<class Pred> Udm::AClassAssocAttr<JavaModel::JAgregation, JavaModel::JClass, Pred> dstJAgregation_sorted(const Pred &) const { return Udm::AClassAssocAttr<JavaModel::JAgregation, JavaModel::JClass, Pred>(impl, meta_dstJAgregation, meta_dstJAgregation_rev); }

		static Uml::AssociationRole meta_src;
		Udm::CrossAssocAttr<UMLModel::Class> src() const { return Udm::CrossAssocAttr<UMLModel::Class>(impl, meta_src); }
		template<class Pred> Udm::CrossAssocAttr<UMLModel::Class, Pred> src_sorted(const Pred &) const { return Udm::CrossAssocAttr<UMLModel::Class, Pred>(impl, meta_src); }

		static Uml::CompositionParentRole meta_Java_parent;
		Udm::ParentAttr<JavaModel::Java> Java_parent() const { return Udm::ParentAttr<JavaModel::Java>(impl, meta_Java_parent); }

		Udm::ParentAttr<JavaModel::MgaObject> parent() const { return Udm::ParentAttr<JavaModel::MgaObject>(impl, Udm::NULLPARENTROLE); }
	};

}

#endif //MOBIES_JAVAMODEL_H
