// cpp(meta datanetwork format) source file UMLModel.cpp generated from diagram UMLModel
// generated on Fri Feb 03 09:37:39 2006

#include "UMLModel.h"
#include "UmlExt.h"

#include "UdmStatic.h"

// cross-package metainformation header file
#include "MI2SI.h"

namespace UMLModel {

	Uml::Diagram umldiagram;

	Uml::Class Attribute::meta;
	Uml::Class Inheritance::meta;
	Uml::Class Operation::meta;
	Uml::Class Agregation::meta;
	Uml::Class Class::meta;
	Uml::Class Feature::meta;
	Uml::Class ClassHasFeature::meta;
	Uml::Class UML::meta;
	Uml::Class RootFolder::meta;
	Uml::Class MgaObject::meta;
	Uml::Attribute RootFolder::meta_name;
	Uml::Attribute MgaObject::meta_position;
	Uml::Attribute MgaObject::meta_name;
	Uml::AssociationRole Inheritance::meta_dst;
	Uml::AssociationRole Inheritance::meta_dstInheritance_end_;
	Uml::AssociationRole Inheritance::meta_srcInheritance_end_;
	Uml::AssociationRole Agregation::meta_dstAgregation_end_;
	Uml::AssociationRole Agregation::meta_srcAgregation_end_;
	Uml::AssociationRole Class::meta_srcInheritance, Class::meta_srcInheritance_rev;
	Uml::AssociationRole Class::meta_dstInheritance, Class::meta_dstInheritance_rev;
	Uml::AssociationRole Class::meta_srcAgregation, Class::meta_srcAgregation_rev;
	Uml::AssociationRole Class::meta_dstAgregation, Class::meta_dstAgregation_rev;
	Uml::AssociationRole Class::meta_dstClassHasFeature, Class::meta_dstClassHasFeature_rev;
	Uml::AssociationRole Class::meta_dst;
	Uml::AssociationRole Feature::meta_srcClassHasFeature, Feature::meta_srcClassHasFeature_rev;
	Uml::AssociationRole ClassHasFeature::meta_srcClassHasFeature_end_;
	Uml::AssociationRole ClassHasFeature::meta_dstClassHasFeature_end_;
	Uml::CompositionParentRole Inheritance::meta_UML_parent;
	Uml::CompositionParentRole Agregation::meta_UML_parent;
	Uml::CompositionParentRole Class::meta_UML_parent;
	Uml::CompositionParentRole Feature::meta_UML_parent;
	Uml::CompositionParentRole ClassHasFeature::meta_UML_parent;
	Uml::CompositionParentRole UML::meta_RootFolder_parent;
	Uml::CompositionParentRole RootFolder::meta_RootFolder_parent;
	Uml::CompositionChildRole UML::meta_Inheritance_children;
	Uml::CompositionChildRole UML::meta_Class_children;
	Uml::CompositionChildRole UML::meta_Agregation_children;
	Uml::CompositionChildRole UML::meta_ClassHasFeature_children;
	Uml::CompositionChildRole UML::meta_Feature_children;
	Uml::CompositionChildRole RootFolder::meta_RootFolder_children;
	Uml::CompositionChildRole RootFolder::meta_UML_children;
	void Creates()
	{
		Attribute::meta = Uml::Class::Create(umldiagram);
		Inheritance::meta = Uml::Class::Create(umldiagram);
		Operation::meta = Uml::Class::Create(umldiagram);
		Agregation::meta = Uml::Class::Create(umldiagram);
		Class::meta = Uml::Class::Create(umldiagram);
		Feature::meta = Uml::Class::Create(umldiagram);
		ClassHasFeature::meta = Uml::Class::Create(umldiagram);
		UML::meta = Uml::Class::Create(umldiagram);
		RootFolder::meta = Uml::Class::Create(umldiagram);
		MgaObject::meta = Uml::Class::Create(umldiagram);
		RootFolder::meta_name = Uml::Attribute::Create(RootFolder::meta);
		MgaObject::meta_position = Uml::Attribute::Create(MgaObject::meta);
		MgaObject::meta_name = Uml::Attribute::Create(MgaObject::meta);
	}
	void InitClassesAttributes()
	{
		Attribute::meta.name() = "Attribute";
		Attribute::meta.isAbstract() = false;
		Attribute::meta.stereotype() = "Atom";
		Inheritance::meta.name() = "Inheritance";
		Inheritance::meta.isAbstract() = false;
		Inheritance::meta.stereotype() = "Connection";
		Operation::meta.name() = "Operation";
		Operation::meta.isAbstract() = false;
		Operation::meta.stereotype() = "Atom";
		Agregation::meta.name() = "Agregation";
		Agregation::meta.isAbstract() = false;
		Agregation::meta.stereotype() = "Connection";
		Class::meta.name() = "Class";
		Class::meta.isAbstract() = false;
		Class::meta.stereotype() = "Atom";
		Feature::meta.name() = "Feature";
		Feature::meta.isAbstract() = false;
		Feature::meta.stereotype() = "Atom";
		ClassHasFeature::meta.name() = "ClassHasFeature";
		ClassHasFeature::meta.isAbstract() = false;
		ClassHasFeature::meta.stereotype() = "Connection";
		UML::meta.name() = "UML";
		UML::meta.isAbstract() = false;
		UML::meta.stereotype() = "Model";
		RootFolder::meta.name() = "RootFolder";
		RootFolder::meta.isAbstract() = false;
		RootFolder::meta.stereotype() = "Folder";
		MgaObject::meta.name() = "MgaObject";
		MgaObject::meta.isAbstract() = true;
		
		RootFolder::meta_name.name() = "name";
		RootFolder::meta_name.type() = "String";
		RootFolder::meta_name.min() = 0;
		RootFolder::meta_name.max() = 1;
		RootFolder::meta_name.nonpersistent() = false;
		RootFolder::meta_name.registry() = false;
		RootFolder::meta_name.ordered() = false;
		RootFolder::meta_name.visibility() = "public";
		RootFolder::meta_name.defvalue() = vector<string>();
		MgaObject::meta_position.name() = "position";
		MgaObject::meta_position.type() = "String";
		MgaObject::meta_position.min() = 0;
		MgaObject::meta_position.max() = 1;
		MgaObject::meta_position.nonpersistent() = false;
		MgaObject::meta_position.registry() = false;
		MgaObject::meta_position.ordered() = false;
		MgaObject::meta_position.visibility() = "public";
		MgaObject::meta_position.defvalue() = vector<string>();
		MgaObject::meta_name.name() = "name";
		MgaObject::meta_name.type() = "String";
		MgaObject::meta_name.min() = 0;
		MgaObject::meta_name.max() = 1;
		MgaObject::meta_name.nonpersistent() = false;
		MgaObject::meta_name.registry() = false;
		MgaObject::meta_name.ordered() = false;
		MgaObject::meta_name.visibility() = "public";
		MgaObject::meta_name.defvalue() = vector<string>();
		
	}
	void InitAssociation0()
	{
		Uml::Association ass = Uml::Association::Create(umldiagram);
		ass.name() = "Inheritance";
		ass.assocClass() = Inheritance::meta;
		Class::meta_srcInheritance = Uml::AssociationRole::Create(ass);
		Class::meta_srcInheritance.name() = "srcInheritance";
		Class::meta_srcInheritance.min() = 0;
		Class::meta_srcInheritance.max() = -1;
		Class::meta_srcInheritance.isNavigable() = true;
		Class::meta_srcInheritance.isPrimary() = false;
		Class::meta_srcInheritance.target() = Class::meta;
		Inheritance::meta_srcInheritance_end_ = Class::meta_dstInheritance_rev = Class::meta_srcInheritance;
		Class::meta_dstInheritance = Uml::AssociationRole::Create(ass);
		Class::meta_dstInheritance.name() = "dstInheritance";
		Class::meta_dstInheritance.min() = 0;
		Class::meta_dstInheritance.max() = -1;
		Class::meta_dstInheritance.isNavigable() = true;
		Class::meta_dstInheritance.isPrimary() = false;
		Class::meta_dstInheritance.target() = Class::meta;
		Inheritance::meta_dstInheritance_end_ = Class::meta_srcInheritance_rev = Class::meta_dstInheritance;
	};
	void InitAssociation1()
	{
		Uml::Association ass = Uml::Association::Create(umldiagram);
		ass.name() = "Agregation";
		ass.assocClass() = Agregation::meta;
		Class::meta_srcAgregation = Uml::AssociationRole::Create(ass);
		Class::meta_srcAgregation.name() = "srcAgregation";
		Class::meta_srcAgregation.min() = 0;
		Class::meta_srcAgregation.max() = -1;
		Class::meta_srcAgregation.isNavigable() = true;
		Class::meta_srcAgregation.isPrimary() = false;
		Class::meta_srcAgregation.target() = Class::meta;
		Agregation::meta_srcAgregation_end_ = Class::meta_dstAgregation_rev = Class::meta_srcAgregation;
		Class::meta_dstAgregation = Uml::AssociationRole::Create(ass);
		Class::meta_dstAgregation.name() = "dstAgregation";
		Class::meta_dstAgregation.min() = 0;
		Class::meta_dstAgregation.max() = -1;
		Class::meta_dstAgregation.isNavigable() = true;
		Class::meta_dstAgregation.isPrimary() = false;
		Class::meta_dstAgregation.target() = Class::meta;
		Agregation::meta_dstAgregation_end_ = Class::meta_srcAgregation_rev = Class::meta_dstAgregation;
	};
	void InitAssociation2()
	{
		Uml::Association ass = Uml::Association::Create(umldiagram);
		ass.name() = "ClassHasFeature";
		ass.assocClass() = ClassHasFeature::meta;
		Class::meta_dstClassHasFeature = Uml::AssociationRole::Create(ass);
		Class::meta_dstClassHasFeature.name() = "dstClassHasFeature";
		Class::meta_dstClassHasFeature.min() = 0;
		Class::meta_dstClassHasFeature.max() = -1;
		Class::meta_dstClassHasFeature.isNavigable() = true;
		Class::meta_dstClassHasFeature.isPrimary() = false;
		Class::meta_dstClassHasFeature.target() = Feature::meta;
		ClassHasFeature::meta_dstClassHasFeature_end_ = Feature::meta_srcClassHasFeature_rev = Class::meta_dstClassHasFeature;
		Feature::meta_srcClassHasFeature = Uml::AssociationRole::Create(ass);
		Feature::meta_srcClassHasFeature.name() = "srcClassHasFeature";
		Feature::meta_srcClassHasFeature.min() = 1;
		Feature::meta_srcClassHasFeature.max() = 1;
		Feature::meta_srcClassHasFeature.isNavigable() = true;
		Feature::meta_srcClassHasFeature.isPrimary() = false;
		Feature::meta_srcClassHasFeature.target() = Class::meta;
		ClassHasFeature::meta_srcClassHasFeature_end_ = Class::meta_dstClassHasFeature_rev = Feature::meta_srcClassHasFeature;
	};
	void InitComposition0()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		Inheritance::meta_UML_parent = Uml::CompositionParentRole::Create(comp);
		Inheritance::meta_UML_parent.name() = "UML_parent";
		Inheritance::meta_UML_parent.isNavigable() = true;
		Inheritance::meta_UML_parent.target() = UML::meta;
		UML::meta_Inheritance_children = Uml::CompositionChildRole::Create(comp);
		UML::meta_Inheritance_children.name() = "Inheritance";
		UML::meta_Inheritance_children.min() = 0;
		UML::meta_Inheritance_children.max() = -1;
		UML::meta_Inheritance_children.isNavigable() = true;
		UML::meta_Inheritance_children.target() = Inheritance::meta;
	}
	void InitComposition1()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		Agregation::meta_UML_parent = Uml::CompositionParentRole::Create(comp);
		Agregation::meta_UML_parent.name() = "UML_parent";
		Agregation::meta_UML_parent.isNavigable() = true;
		Agregation::meta_UML_parent.target() = UML::meta;
		UML::meta_Agregation_children = Uml::CompositionChildRole::Create(comp);
		UML::meta_Agregation_children.name() = "Agregation";
		UML::meta_Agregation_children.min() = 0;
		UML::meta_Agregation_children.max() = -1;
		UML::meta_Agregation_children.isNavigable() = true;
		UML::meta_Agregation_children.target() = Agregation::meta;
	}
	void InitComposition2()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		Class::meta_UML_parent = Uml::CompositionParentRole::Create(comp);
		Class::meta_UML_parent.name() = "UML_parent";
		Class::meta_UML_parent.isNavigable() = true;
		Class::meta_UML_parent.target() = UML::meta;
		UML::meta_Class_children = Uml::CompositionChildRole::Create(comp);
		UML::meta_Class_children.name() = "Class";
		UML::meta_Class_children.min() = 0;
		UML::meta_Class_children.max() = -1;
		UML::meta_Class_children.isNavigable() = true;
		UML::meta_Class_children.target() = Class::meta;
	}
	void InitComposition3()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		Feature::meta_UML_parent = Uml::CompositionParentRole::Create(comp);
		Feature::meta_UML_parent.name() = "UML_parent";
		Feature::meta_UML_parent.isNavigable() = true;
		Feature::meta_UML_parent.target() = UML::meta;
		UML::meta_Feature_children = Uml::CompositionChildRole::Create(comp);
		UML::meta_Feature_children.name() = "Feature";
		UML::meta_Feature_children.min() = 0;
		UML::meta_Feature_children.max() = -1;
		UML::meta_Feature_children.isNavigable() = true;
		UML::meta_Feature_children.target() = Feature::meta;
	}
	void InitComposition4()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		ClassHasFeature::meta_UML_parent = Uml::CompositionParentRole::Create(comp);
		ClassHasFeature::meta_UML_parent.name() = "UML_parent";
		ClassHasFeature::meta_UML_parent.isNavigable() = true;
		ClassHasFeature::meta_UML_parent.target() = UML::meta;
		UML::meta_ClassHasFeature_children = Uml::CompositionChildRole::Create(comp);
		UML::meta_ClassHasFeature_children.name() = "ClassHasFeature";
		UML::meta_ClassHasFeature_children.min() = 0;
		UML::meta_ClassHasFeature_children.max() = -1;
		UML::meta_ClassHasFeature_children.isNavigable() = true;
		UML::meta_ClassHasFeature_children.target() = ClassHasFeature::meta;
	}
	void InitComposition5()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		UML::meta_RootFolder_parent = Uml::CompositionParentRole::Create(comp);
		UML::meta_RootFolder_parent.name() = "RootFolder_parent";
		UML::meta_RootFolder_parent.isNavigable() = true;
		UML::meta_RootFolder_parent.target() = RootFolder::meta;
		RootFolder::meta_UML_children = Uml::CompositionChildRole::Create(comp);
		RootFolder::meta_UML_children.name() = "UML";
		RootFolder::meta_UML_children.min() = 0;
		RootFolder::meta_UML_children.max() = -1;
		RootFolder::meta_UML_children.isNavigable() = true;
		RootFolder::meta_UML_children.target() = UML::meta;
	}
	void InitComposition6()
	{
		Uml::Composition comp = Uml::Composition::Create(umldiagram);
		comp.nonpersistent() =false;
		RootFolder::meta_RootFolder_parent = Uml::CompositionParentRole::Create(comp);
		RootFolder::meta_RootFolder_parent.name() = "RootFolder_parent";
		RootFolder::meta_RootFolder_parent.isNavigable() = true;
		RootFolder::meta_RootFolder_parent.target() = RootFolder::meta;
		RootFolder::meta_RootFolder_children = Uml::CompositionChildRole::Create(comp);
		RootFolder::meta_RootFolder_children.name() = "RootFolder";
		RootFolder::meta_RootFolder_children.min() = 0;
		RootFolder::meta_RootFolder_children.max() = -1;
		RootFolder::meta_RootFolder_children.isNavigable() = true;
		RootFolder::meta_RootFolder_children.target() = RootFolder::meta;
	}
	 void Initialize()
	{
		static bool first = true;
		if(!first) return;
		first = false;
		Uml::Initialize();

		MI2SI::Initialize();

		ASSERT( umldiagram == Udm::null );
		UdmStatic::StaticDataNetwork * meta_dn = new UdmStatic::StaticDataNetwork(Uml::diagram);
		meta_dn->CreateNew("UMLModel.mem", "", Uml::Diagram::meta, Udm::CHANGES_LOST_DEFAULT);
		umldiagram = Uml::Diagram::Cast(meta_dn->GetRootObject());
		umldiagram.name() ="UMLModel";
		umldiagram.version() ="1.00";
		Creates();
		InitClassesAttributes();
		Uml::InitDiagram(umldiagram, "UMLModel", "1.00");

		InitAssociation0();
		InitAssociation1();
		InitAssociation2();
		InitComposition0();
		InitComposition1();
		InitComposition2();
		InitComposition3();
		InitComposition4();
		InitComposition5();
		InitComposition6();
		Inheritance::meta_dst = MI2SI::Inheritance_cross_ph_UMLModel::meta_dst;
		Class::meta_dst = MI2SI::Class_cross_ph_UMLModel::meta_dst;
		Attribute::meta.subTypes() +=  Operation::meta;
		Attribute::meta.subTypes() +=  Feature::meta;
		MgaObject::meta.subTypes() +=  Attribute::meta;
		MgaObject::meta.subTypes() +=  Inheritance::meta;
		MgaObject::meta.subTypes() +=  Agregation::meta;
		MgaObject::meta.subTypes() +=  Class::meta;
		MgaObject::meta.subTypes() +=  ClassHasFeature::meta;
		MgaObject::meta.subTypes() +=  UML::meta;
		
	}
	 void Initialize(const Uml::Diagram & dgr)
	{
		umldiagram = dgr;
		Uml::SetClass(Attribute::meta, umldiagram, "Attribute");
		Uml::SetClass(Inheritance::meta, umldiagram, "Inheritance");
		Uml::SetClass(Operation::meta, umldiagram, "Operation");
		Uml::SetClass(Agregation::meta, umldiagram, "Agregation");
		Uml::SetClass(Class::meta, umldiagram, "Class");
		Uml::SetClass(Feature::meta, umldiagram, "Feature");
		Uml::SetClass(ClassHasFeature::meta, umldiagram, "ClassHasFeature");
		Uml::SetClass(UML::meta, umldiagram, "UML");
		Uml::SetClass(RootFolder::meta, umldiagram, "RootFolder");
		Uml::SetAttribute(RootFolder::meta_name,RootFolder::meta, "name");
		Uml::SetClass(MgaObject::meta, umldiagram, "MgaObject");
		Uml::SetAttribute(MgaObject::meta_position,MgaObject::meta, "position");
		Uml::SetAttribute(MgaObject::meta_name,MgaObject::meta, "name");
		//composition child roles 
		Uml::SetParentRole(Inheritance::meta_UML_parent,Inheritance::meta,UML::meta, "", "");
		Uml::SetParentRole(Agregation::meta_UML_parent,Agregation::meta,UML::meta, "", "");
		Uml::SetParentRole(Class::meta_UML_parent,Class::meta,UML::meta, "", "");
		Uml::SetParentRole(Feature::meta_UML_parent,Feature::meta,UML::meta, "", "");
		Uml::SetParentRole(ClassHasFeature::meta_UML_parent,ClassHasFeature::meta,UML::meta, "", "");
		Uml::SetParentRole(UML::meta_RootFolder_parent,UML::meta,RootFolder::meta, "", "");
		Uml::SetParentRole(RootFolder::meta_RootFolder_parent,RootFolder::meta,RootFolder::meta, "", "");
		// composition parentroles 
		Uml::SetChildRole(UML::meta_Inheritance_children,UML::meta,Inheritance::meta, "", "");
		Uml::SetChildRole(UML::meta_Class_children,UML::meta,Class::meta, "", "");
		Uml::SetChildRole(UML::meta_Agregation_children,UML::meta,Agregation::meta, "", "");
		Uml::SetChildRole(UML::meta_ClassHasFeature_children,UML::meta,ClassHasFeature::meta, "", "");
		Uml::SetChildRole(UML::meta_Feature_children,UML::meta,Feature::meta, "", "");
		Uml::SetChildRole(RootFolder::meta_RootFolder_children,RootFolder::meta,RootFolder::meta, "", "");
		Uml::SetChildRole(RootFolder::meta_UML_children,RootFolder::meta,UML::meta, "", "");
		// Association roles 
		Uml::SetAssocRole(Class::meta_srcInheritance,Class::meta,Class::meta, "dstInheritance");
		Class::meta_dstInheritance_rev = Class::meta_srcInheritance;
		Uml::SetAssocRole(Class::meta_dstInheritance,Class::meta,Class::meta, "srcInheritance");
		Class::meta_srcInheritance_rev = Class::meta_dstInheritance;
		Uml::SetAssocRole(Class::meta_srcAgregation,Class::meta,Class::meta, "dstAgregation");
		Class::meta_dstAgregation_rev = Class::meta_srcAgregation;
		Uml::SetAssocRole(Class::meta_dstAgregation,Class::meta,Class::meta, "srcAgregation");
		Class::meta_srcAgregation_rev = Class::meta_dstAgregation;
		Uml::SetAssocRole(Class::meta_dstClassHasFeature,Class::meta,Feature::meta, "srcClassHasFeature");
		Feature::meta_srcClassHasFeature_rev = Class::meta_dstClassHasFeature;
		Uml::SetAssocRole(Feature::meta_srcClassHasFeature,Feature::meta,Class::meta, "dstClassHasFeature");
		Class::meta_dstClassHasFeature_rev = Feature::meta_srcClassHasFeature;

		Inheritance::meta_dstInheritance_end_ = Class::meta_dstInheritance;
		Inheritance::meta_srcInheritance_end_ = Class::meta_srcInheritance;


		Agregation::meta_dstAgregation_end_ = Class::meta_dstAgregation;
		Agregation::meta_srcAgregation_end_ = Class::meta_srcAgregation;



		ClassHasFeature::meta_srcClassHasFeature_end_ = Feature::meta_srcClassHasFeature;
		ClassHasFeature::meta_dstClassHasFeature_end_ = Class::meta_dstClassHasFeature;




		
	}
	 Udm::UdmDiagram diagram = { &umldiagram, Initialize };
	static struct _regClass
	{
		_regClass()
		{
			Udm::MetaDepository::StoreDiagram("UMLModel", diagram);
		};
		~_regClass()
		{
			Udm::MetaDepository::RemoveDiagram("UMLModel");
		};
	} __regUnUsed;

}
// END UMLModel.cpp
